/*****************************************************************************/
/* mainForm.java sample code						     */
/*****************************************************************************/
/*									     */
/* MODULE:	MainForm.java						     */
/*									     */
/* TITLE/PURPOSE/SUMMARY:						     */
/*									     */
/* PRODUCT:								     */
/*									     */
/* VERSION: 0.00							     */
/*									     */
/* AUTHOR:								     */
/*									     */
/* DATE:	02-10-04						     */
/*									     */
/* COPYRIGHT  (c) 2004 QVS Software Inc,				     */
/*				ALL RIGHTS RESERVED			     */
/*									     */
/* NOTES:								     */
/*****************************************************************************/
/* CHANGES								     */
/*									     */
/* #04 01/25/06 NYH							     */
/*     Support for writing/reading Hard Totals to/from total.txt file.	     */
/* #03 05/04/05 JJF							     */
/*     Support for using SERIAL3 and SERIAL4				     */
/* #02 04/20/04 DAM							     */
/*     Added buttons for manually keying different credit card numbers.      */
/* #01 02/10/04 JJF							     */
/*     Original version sample code.					     */
/*****************************************************************************/
package javasamp;

import java.awt.*;
import java.util.*;
import java.util.Vector;

import qvs.*;
import qvs.RPAMEventListener;
import qvs.RPAMEvents.*;
import qvs.RPAMDevices.*;

import qvs.RPAMApp;
import qvs.RPAMTerminal;
import qvs.RPAMDevices.POSDisplay;
import java.awt.event.*;
import javax.swing.*;

import java.io.*;
import java.util.Properties;

public class MainForm extends JDialog implements qvs.RPAMEventListenerEx2, qvs.RPAMGlobals,
					     POSKybdListener,
					     VDisplayEventListener
   {
   RPAMTerminal Term;
   RPAMApp App;
   Integer TermNum;
   Integer UnitID;
   Integer StoreNum;
   SerialEventHandler Serial1Handler;  /* an instance of the SerialEvent     */
   SerialEventHandler Serial2Handler;  /* an instance of the SerialEvent     */

   SerialEventHandler Serial3Handler;  /* an instance of the SerialEvent     */
   SerialEventHandler Serial4Handler;  /* an instance of the SerialEvent     */

   static int FirstVDispEventReceived = 0;
   int m_EnableVDisplay=0;
   int m_AutoConnectEnabled=0;
   int AppHardTotals=0;
   String TCAddr;
   byte [] totals;
   File inputFile = new File("totals.txt");                          /* #04a[*/
   File outputFile = new File("totals.txt");
   FileReader totalsIn;
   FileWriter totalsOut;
   String totStr;						     /* #04a]*/
   int state;
   int lastState;
   int keyEnter;
   boolean alpha;

   JTextField Row1;
   JTextField Row2;
   JTextField UnitEdit;
   JTextField TermEdit;
   JTextField scanEdit;
   JLabel UnitLabel;
   JLabel TermLabel;
   JCheckBox  Connect;
   JCheckBox  MgrKey;
   JButton StartBtn;
   JButton scanBtn;
   JButton visaBtn;
   JButton amexBtn;
   JButton discBtn;
   JButton mcardBtn;
   JButton disconnectBtn;
   JButton setAddrBtn;
   POSKybd Keyboard;
   JLabel StatusLabel;
   JLabel TermStatus;
   JTextField AddrEdit;

   JScrollPane ScrlPane;
   JList Receipt;
   DefaultListModel ReceiptModel;
   String CodeString = "";

   JCheckBox  EnableVDisplay;
   JCheckBox  EnableSerial1;
   JCheckBox  EnableSerial2;
   JCheckBox  EnableSerial3;
   JCheckBox  EnableSerial4;
   JCheckBox  Enable4610;

   JPanel jPanel1 = new JPanel();
   JCheckBox  CodeMode;
   JCheckBox  DIDocPresent;
   static int exe_cnt = 0;
				       /* up to max 99K CMOS		     */
   static final int CMOS_MAX_SIZE = (100 * 1536);

   public MainForm()
      {
      Init("","", 0, 0, 0, "");
      }

   public MainForm(String TermNum, String StoreNum, int pEnableVDisplay, int pAutoConnectEnabled, int AppHardTotals, String TCAddr)
      {
      Init(TermNum, StoreNum, pEnableVDisplay, pAutoConnectEnabled, AppHardTotals, TCAddr);
      }

   public String ByteArrToString(byte[] arr, int start, int len)
      {
      String RetVal = "";
      int i;
      for (i=start;i<start+len;i++)
	 {
	 RetVal = RetVal + (char)arr[i];
	 }
      return RetVal;
      }

   public byte[] StringToByteArr(String str)
      {
      int Len = str.length();
      byte[] RetVal = new byte[Len];
      int i;
      for (i=0;i<Len;i++)
	 {
	 RetVal[i] = (byte)(str.charAt(i));
	 }
      return RetVal;

      }

    public void Init(String TermNum, String StoreNum, int pEnableVDisplay, int pAutoConnectEnabled, int AppHardTotals, String TCAddr)
      {
      int ANDHeight = 23;
      int ANDWidth = 285;
      int ANDX = 5;
      int ANDY = 50;
      int x;

      if (TermNum.length() == 0)
	 {
	 TermNum = "1";
	 }

      if (StoreNum.length() == 0)
	 {
	 StoreNum = "0";
	 }

      this.TermNum = new Integer(TermNum);
      this.StoreNum = new Integer(StoreNum);
      this.UnitID = new Integer(1);
      this.TCAddr = TCAddr;
      m_EnableVDisplay = pEnableVDisplay;
      m_AutoConnectEnabled = pAutoConnectEnabled;
      this.AppHardTotals = AppHardTotals;

      Serial1Handler = new SerialEventHandler(1);
      Serial2Handler = new SerialEventHandler(2);
      Serial3Handler = new SerialEventHandler(3);
      Serial4Handler = new SerialEventHandler(4);

      try
	 {
	 jbInit();
	 }
      catch(Exception e)
	 {
	 e.printStackTrace();
	 }

      int jWidth  = 880;   // width  main
      int jHeight = 560;   // height main
      setBounds(100,100,jWidth,jHeight);
      getContentPane().setLayout(null);

      Row1 = new JTextField();
      getContentPane().add(Row1);
      Row1.setBounds(ANDX,ANDY,ANDWidth,ANDHeight);
      Row1.setBorder(null);
      Row1.setBackground(Color.black);
      Row1.setForeground(Color.green);
      Row1.setFont(new Font("Monospaced", Font.BOLD, 21));

      Row2 = new JTextField();
      getContentPane().add(Row2);
      Row2.setBounds(ANDX,ANDY+ANDHeight,ANDWidth,ANDHeight);
      Row2.setBorder(null);
      Row2.setBackground(Color.black);
      Row2.setForeground(Color.green);
      Row2.setFont(new Font("Monospaced", Font.BOLD, 21));

      UnitLabel = new JLabel();
      getContentPane().add(UnitLabel);
      UnitLabel.setBounds(ANDX, ANDX, 20, 25);
      UnitLabel.setText("ID");
      UnitLabel.setDisplayedMnemonic('I');
      UnitLabel.setForeground(Color.black);

      UnitEdit = new JTextField();
      getContentPane().add(UnitEdit);
      UnitEdit.setBounds(ANDX+20,ANDX,40,25);
      UnitEdit.setBorder(BorderFactory.createLoweredBevelBorder());
      UnitEdit.setText(this.UnitID.toString());
      UnitEdit.setFocusAccelerator('I');

      TermLabel = new JLabel();
      getContentPane().add(TermLabel);
      TermLabel.setBounds(ANDX+20+40+10, ANDX, 40, 25);
      TermLabel.setText("Term");
      TermLabel.setDisplayedMnemonic('M');
      TermLabel.setForeground(Color.black);

      TermEdit = new JTextField();
      getContentPane().add(TermEdit);
      TermEdit.setBounds(ANDX+20+40+10+40,ANDX,40,25);
      TermEdit.setBorder(BorderFactory.createLoweredBevelBorder());
      getContentPane().add(TermEdit);
      TermEdit.setText(this.TermNum.toString());
      TermEdit.setFocusAccelerator('M');

      Connect = new JCheckBox();
      getContentPane().add(Connect);
      Connect.setBounds(ANDX+20+40+10+40+10+40, ANDX-5, 80, 25);
      Connect.setText("Connect");
      Connect.setMnemonic('N');

      MgrKey = new JCheckBox();
      getContentPane().add(MgrKey);
      MgrKey.setBounds(ANDX+20+40+10+40+10+40, ANDX+15, 80, 25);
      MgrKey.setText("MgrKey");
      MgrKey.setMnemonic('K');
      MgrKey.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    MgrKeyButtonPressed();
	    }
	 });

      StartBtn = new JButton();
      getContentPane().add(StartBtn);
      StartBtn.setBounds(ANDX+20+40+10+40+10+40+10+65, ANDX, 95, 35);
      StartBtn.setBorder(BorderFactory.createRaisedBevelBorder());
      StartBtn.setText("Start Term");
      StartBtn.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    StartButtonPressed();
	    }
	 });
      StartBtn.setMnemonic('A');

      scanBtn = new JButton();
      getContentPane().add(scanBtn);
      scanBtn.setBounds(420, 320, 120, 25);
      scanBtn.setBorder(BorderFactory.createRaisedBevelBorder());
      scanBtn.setText("Send Scan");
      scanBtn.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    scanButtonPressed();
	    }
	 });

      visaBtn = new JButton();
      getContentPane().add(visaBtn);
      visaBtn.setBounds(420, 350, 120, 25);
      visaBtn.setBorder(BorderFactory.createRaisedBevelBorder());
      visaBtn.setText("Key Visa");
      visaBtn.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    visaButtonPressed();
	    }
	 });

      mcardBtn = new JButton();
      getContentPane().add(mcardBtn);
      mcardBtn.setBounds(420, 380, 120, 25);
      mcardBtn.setBorder(BorderFactory.createRaisedBevelBorder());
      mcardBtn.setText("Key MCard");
      mcardBtn.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    mcardButtonPressed();
	    }
	 });

      amexBtn = new JButton();
      getContentPane().add(amexBtn);
      amexBtn.setBounds(420, 410, 120, 25);
      amexBtn.setBorder(BorderFactory.createRaisedBevelBorder());
      amexBtn.setText("Key Amex");
      amexBtn.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    amexButtonPressed();
	    }
	 });

      discBtn = new JButton();
      getContentPane().add(discBtn);
      discBtn.setBounds(420, 440, 120, 25);
      discBtn.setBorder(BorderFactory.createRaisedBevelBorder());
      discBtn.setText("Key Discover");
      discBtn.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    discButtonPressed();
	    }
	 });

      disconnectBtn = new JButton();
      getContentPane().add(disconnectBtn);
      disconnectBtn.setBounds(420,  10, 120, 25);
      disconnectBtn.setBorder(BorderFactory.createRaisedBevelBorder());
      disconnectBtn.setText("Disconnect");
      disconnectBtn.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    Term.setUnitID(0);
	    }
	 });

      scanEdit = new JTextField();
      scanEdit.setBounds(550, 320, 205, 25);
      scanEdit.setBorder(BorderFactory.createLoweredBevelBorder());
      getContentPane().add(scanEdit);

      Keyboard = new POSKybd();
      Keyboard.addPOSKybdListener(this);
      this.setTitle("TC Java Socket Client [Keymap " + Keyboard.prefix + "]" );
      getContentPane().add(Keyboard);

      keyEnter = 95;		       /* Use GSA/CSA as default ENTER key   */
      if (Keyboard.prefix.startsWith("SA"))
	 {
	 keyEnter = 80; 	       /* SA ENTER key			     */
	 }
      ScrlPane = new JScrollPane();
      ScrlPane.setLayout(null);
      ScrlPane.setBorder(null);
      ScrlPane.setBounds(5, 315, 330, 165);

      Receipt = new JList();

      ReceiptModel = new DefaultListModel();
      ReceiptModel.ensureCapacity(1000);
      Receipt.setModel(ReceiptModel);
      Receipt.setFont(new java.awt.Font("Monospaced", 1, 14));
      Receipt.setFixedCellHeight(25);
      Receipt.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

      ScrlPane.getViewport().add(Receipt);
      ScrlPane.getViewport().setBounds(0, 0, 330, 165);
      ScrlPane.getViewport().setView(Receipt);
      ScrlPane.getViewport().setVisible(true);
      Receipt.setVisible(true);
      ScrlPane.setVisible(true);

      Receipt.setSelectedIndex(ReceiptModel.size()-1);
      Receipt.ensureIndexIsVisible(ReceiptModel.size()-1);
      getContentPane().add(ScrlPane);

      DIDocPresent = new JCheckBox();
      getContentPane().add(DIDocPresent);
      DIDocPresent.setBounds(5, 485, 120, 25);
      DIDocPresent.setText("DI Doc Present");
      DIDocPresent.setMnemonic('P');

      DIDocPresent.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    if (DIDocPresent.getModel().isSelected())
	       {
	       Term.getPrinter().putDIDocPresent(true);
	       }
	    else
	       {
	       Term.getPrinter().putDIDocPresent(false);
	       }
	    }
	 });

      EnableSerial1 =  new JCheckBox();
      getContentPane().add(EnableSerial1);
      EnableSerial1.setBounds(5, 505, 120, 25);
      EnableSerial1.setText("Enable Ser1");

      EnableSerial2 =  new JCheckBox();
      getContentPane().add(EnableSerial2);
      EnableSerial2.setBounds(135, 505, 90, 25);
      EnableSerial2.setText("Enable Ser2");

      EnableVDisplay = new JCheckBox();
      getContentPane().add(EnableVDisplay);
      EnableVDisplay.setBounds(225, 485, 165, 25);
      EnableVDisplay.setText("Enable VDisplay");
      EnableVDisplay.setMnemonic('V');
      if (m_EnableVDisplay == 1)
	 {
	 EnableVDisplay.getModel().setSelected(true);
	 }

      EnableSerial3 =  new JCheckBox();
      getContentPane().add(EnableSerial3);
      EnableSerial3.setBounds(390, 485, 120, 25);
      EnableSerial3.setText("Enable Ser3");

      EnableSerial4 =  new JCheckBox();
      getContentPane().add(EnableSerial4);
      EnableSerial4.setBounds(390, 505, 120, 25);
      EnableSerial4.setText("Enable Ser4");

      Enable4610 =  new JCheckBox();
      getContentPane().add(Enable4610);
      Enable4610.setBounds(225, 505, 165, 25);
      Enable4610.setText("4610 Printer");

      StatusLabel = new JLabel();
      getContentPane().add(StatusLabel);
      StatusLabel.setBounds(420, ANDY, 45, 25);
      StatusLabel.setText("Status:");
      StatusLabel.setForeground(Color.black);

      TermStatus = new JLabel();
      getContentPane().add(TermStatus);
      TermStatus.setBounds(470, ANDY, 500, 25);
      TermStatus.setText("");
      TermStatus.setForeground(Color.black);

      AddrEdit = new JTextField();
      getContentPane().add(AddrEdit);
      AddrEdit.setBounds(560,10,100,25);
      AddrEdit.setBorder(BorderFactory.createLoweredBevelBorder());
      getContentPane().add(AddrEdit);
      AddrEdit.setText("");

      setAddrBtn = new JButton();
      getContentPane().add(setAddrBtn);
      setAddrBtn.setBounds(670,  10, 120, 25);
      setAddrBtn.setBorder(BorderFactory.createRaisedBevelBorder());
      setAddrBtn.setText("SetAddr");
      setAddrBtn.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    App.setTCServerAddresses(AddrEdit.getText(), "");
	    }
	 });


      CodeMode = new JCheckBox();
      getContentPane().add(CodeMode);
      CodeMode.setBounds(135, 485, 90, 25);
      CodeMode.setText("CodeMode");
      CodeMode.setMnemonic('V');
      CodeMode.addActionListener(new ActionListener()
	 {
	 public void actionPerformed(ActionEvent e)
	    {
	    if (CodeMode.getModel().isSelected())
	       {
	       Keyboard.gCodeMode = 1;
	       }
	    else
	       {
	       Keyboard.gCodeMode = 0;
	       }
	    }
	 });

      Term = new RPAMTerminal();
      Term.addRPAMEventListener(this);

				       /* add a 'monitor' object to demo the */
				       /* fact that you can have more than   */
				       /* one listener on a terminal.	     */
      RPAMMonitor rpamMonitor = new RPAMMonitor();
      Term.addRPAMEventListener(rpamMonitor);

      App = new RPAMApp();
      if (m_AutoConnectEnabled == 1)
	 {
	 Connect.getModel().setSelected(true);
	 StartButtonPressed();
	 }

      totals = new byte[CMOS_MAX_SIZE];/* support up tp 99K CMOS	     */

      if (this.AppHardTotals == 1)
	 {
	 try							     /* #04a[*/
	    {
	    totalsIn = new FileReader(inputFile);
	    for (x=0;x<CMOS_MAX_SIZE;x++)
	       {
	       totals[x] = (byte)totalsIn.read();
	       }
	    totalsIn.close();
	    }
	 catch(Exception e)
	    {							     /* #04a]*/
	    for (x=0;x<CMOS_MAX_SIZE;x++)
	       {
	       totals[x] = (byte)0;
	       }

	    FlushTotalsFile();					     /* #04a */
	    }							     /* #04a */
	 }
      }

   public void StatusMsg(String msg)
      {
      TermStatus.setText(msg);
      }

   public void DoFileOp()
      {
      POSFile PFile;
      POSKeyedFile PKFile;
      PFile = new POSFile();
      PKFile = new POSKeyedFile();
      int x;
      int y;
      int BytesRead=0;
      int CumBytesRead;
      int Offset;
      byte[] buf = new byte[25];
      int rc;


      PFile.setUnitID(1);
      PFile.setName("R::ADX_UDT1\\FILEOP.DAT");


      // create the file with read/write/delete permissions
      PFile.Create(rpaFlgDelete + rpaFlgWrite + rpaFlgRead , 0, 0, 0);	//size was 0x400, 2nd param

      if (PFile.getErrorCode4690() == 0)
	 {
	 // now write some data to the file

	 for (x=0;x<20;x++)
	    {
	    for (y=0;y<25;y++)
	      buf[y] = (byte)(x + 0x30);

	    PFile.Write(rpaSeekFP + rpaTruncate, buf, 25, 0);

	    }
	    // close the file
	    PFile.Close();
	 }
      else
	 {
	 System.out.println("Create of FILEOP.DAT failed " +
						    PFile.getErrorCode4690());
	 }

	 // now read in a couple of buffers from the file
	 PFile.Open(rpaFlgRead, 0);
	 if (PFile.getErrorCode4690() == 0)
	    {
	    // read 25 bytes from offset 35
	    BytesRead = PFile.Read(rpaSeekBOF, buf, 25, 35);

	    // read 12 bytes from offset 47
	    BytesRead = PFile.Read(rpaSeekBOF, buf, 12, 47);

	    // now read sequentially through the file
	    BytesRead = 1;
	    CumBytesRead = 0;
	    Offset = 0;
	    while (BytesRead > 0)
	       {
	       BytesRead = PFile.Read(rpaSeekBOF, buf, 24, Offset);
	       if (BytesRead == 0)
		  {
		  System.out.println("EOF found, cumulative bytes read " +
								 CumBytesRead);
		  System.out.println("ErrCode  " + PFile.getErrorCode4690());
		  }
	       else if (BytesRead <0)
		  {
		  System.out.println("4690 error " + PFile.getErrorCode4690());
		  }
	       else
		  {
		  CumBytesRead = CumBytesRead + BytesRead;
		  Offset = Offset + BytesRead;
		  }
	       }
	    // close the file
	    PFile.Close();
	    }

      // now do some keyed file ops
      // set the unit ID and name
      // unit ID must match unit ID of the terminal you want to
      // use
      PKFile.setUnitID(1);
      PKFile.setName("R::ADX_UDT1\\KEYED.FIL");

      // open the file with read/write permissions
      PKFile.Open(rpaFlgWrite + rpaFlgRead , 0);
      if (PKFile.getErrorCode4690() == 0)
	 {
	 // write a record with key value 'KEY02' to the file
	 // the sample keyed file 'KEYED.FIL' has record length
	 // of 20 with a key length of 5
	 buf = StringToByteArr("KEY02X_____________Y");
	 rc = PKFile.Write(0, buf, 20);
	 buf = StringToByteArr("KEY98XjjfjjfjjfjjfjY");
	 rc = PKFile.Write(0, buf, 20);
	 buf = StringToByteArr("KEY99X9_9_9_9_9_9_9Y");
	 rc = PKFile.Write(0, buf, 20);
	 buf = StringToByteArr("KEY9AX9a9a9a9a9a9a9Y");
	 rc = PKFile.Write(0, buf, 20);

	 // put the key value to read in the buffer
	 buf = StringToByteArr("                    ");
	 buf = StringToByteArr("KEY02               ");

	 // read the data
	 rc = PKFile.Read(0, buf, 20, 5);

	 // delete some records
	 buf = StringToByteArr("KEY01");
	 rc = PKFile.DeleteRecord(buf, 5);
	 buf = StringToByteArr("KEY98");
	 rc = PKFile.DeleteRecord(buf, 5);

	 // close the file
	 PKFile.Close(0);
	 }
      }

   public void MgrKeyButtonPressed()
      {
      int keypos = (MgrKey.getModel().isSelected()) ? 1 : 0;
      Term.getKeyboard().setKeylockPosition(keypos);
      System.out.println("Mgr key " + keypos);
      }

   public void scanButtonPressed()
      {
      Term.getScanner().SendScannerData(0xFE, scanEdit.getText());
      }

   public void visaButtonPressed()
      {
      String numStr = "";
      int cnt,x,FCode;
      numStr = "4000000000000002"; // visa
      cnt = numStr.length();
      for (x=0;x<cnt;x++)
	 {
	 FCode = (int)numStr.charAt(x);
	 SendFCode(FCode);
	 }
      SendFCode(keyEnter);
      }

   public void mcardButtonPressed()
      {
      String numStr = "";
      int cnt,x,FCode;
      numStr = "5400000000000005"; // mcard
      cnt = numStr.length();
      for (x=0;x<cnt;x++)
	 {
	 FCode = (int)numStr.charAt(x);
	 SendFCode(FCode);
	 }
      SendFCode(keyEnter);
      }

   public void amexButtonPressed()
      {
      String numStr = "";
      int cnt,x,FCode;
      numStr = "370000000000002"; // amex
      cnt = numStr.length();
      for (x=0;x<cnt;x++)
	 {
	 FCode = (int)numStr.charAt(x);
	 SendFCode(FCode);
	 }
      SendFCode(keyEnter);
      }

   public void discButtonPressed()
      {
      String numStr = "";
      int cnt,x,FCode;
      numStr = "6011000000000004"; // discover
      cnt = numStr.length();
      for (x=0;x<cnt;x++)
	 {
	 FCode = (int)numStr.charAt(x);
	 SendFCode(FCode);
	 }
      SendFCode(keyEnter);
      }

   public void StartButtonPressed()
      {
      try
      {
      if (TCAddr.compareTo("") != 0)
	 {
	 App.setTCServerAddresses(TCAddr, "");
	 }
      App.setTracing(1);
      App.setTermNumAssignMode(rpaAppTermNum);
      /* App.setStartingTermNum(9); */
      UnitID = Integer.valueOf(UnitEdit.getText());
      Term.setUnitID(UnitID.intValue());

      Term.getPrinter().setDeviceID(rpaMod34prt);
      Term.getPrinter().putMICRAttached(true);
      Row1.setText("Waiting For");
      Row2.setText("Online Event");
      App.setOptimizeDisplay(0);
      App.setStoreNum(StoreNum.intValue());   /* TESTING purposes only	     */

//    Term.getCashDrawer().setDrawerOpenMsec(100);

      if (EnableSerial1.getModel().isSelected())
	 {
	 Term.getSerial1().setDeviceEnabled();
	 }

      if (EnableSerial2.getModel().isSelected())
	 {
	 Term.getSerial2().setDeviceEnabled();
	 }

      if (EnableSerial3.getModel().isSelected())
	 {
	 Term.getSerial3().setDeviceEnabled();
	 }
      if (EnableSerial4.getModel().isSelected())
	 {
	 Term.getSerial4().setDeviceEnabled();
	 }

      if (Enable4610.getModel().isSelected())
	 {
	 Term.getPrinter().setDeviceID(rpa4610prt);
	 }
      else
	 {
	 Term.getPrinter().setDeviceID(rpaMod34prt);
	 }

      if (AppHardTotals != 0)
	 {
	 Term.getHardTotals().setDeviceResponseMode(rpaAppDeviceResponse);
	 }
/*
JJF - 10/27/03
Bug was found and fixed in RPAMFUNC client code.  Auto response should have
been the default but was not.  This call is no longer required.
      else
	 {
	 Term.getHardTotals().setDeviceResponseMode(rpaAutoDeviceResponse);
	 }
*/

      Term.getSerial1().addSerialEventListener(Serial1Handler);
      Term.getSerial2().addSerialEventListener(Serial2Handler);
      Term.getSerial3().addSerialEventListener(Serial3Handler);
      Term.getSerial4().addSerialEventListener(Serial4Handler);
      Term.getVDisplay().addVDisplayEventListener(this);

      Term.getScale().Enable();

/* Enable the VDISPLAY device if asked to do so. */
      if (EnableVDisplay.getModel().isSelected())
	 {
	 POSVDisplay vd = Term.getVDisplay();
	 Term.getVDisplay().setDeviceEnabled();

	 /*
	 This just shows that the properties of the VDISPLAY object
	 are invalid until the first CursorVisibilityChangeEvent
	 is received
	 */

	 /*
	 System.out.println("fmt: " + vd.DisplayFormat);
	 System.out.println("cur: " + vd.CursorVisible);
	 System.out.println("undl: " + vd.VGAUnderlining);
	 System.out.println("intens: " + vd.VGAIntensifyBackground);
	 System.out.println("attrtype: " + vd.AttributeType);
	 System.out.println("curr attr: " + vd.CurrentAttribute);
	 System.out.println("disptype: " + vd.DisplayType);
	 */
	 }

				       /* it's highly recommeded that you    */
				       /* turn off field level input	     */
				       /* processing unless you know exactly */
				       /* why you want it.		     */
      Term.getIOProc().putFieldLevelInputMode(FL_NONE);

      Term.getMsr().setDeviceID(0x40);

      if (Connect.getModel().isSelected())
	 {
	 if (AppHardTotals != 0)
	    {
	    Term.setTermNum(0);
	    TermEdit.setText("0");
	    }
	 else
	    {
	    Term.setTermNum(Integer.valueOf(TermEdit.getText()).intValue());
	    }
	 StatusMsg("Attemping to connect...");
	 Term.Connect();
	 }
      else
	 {
	 Row1.setText(Term.getANDisplay().getRow1Text());
	 Row2.setText(Term.getANDisplay().getRow2Text());
	 }
      }
      catch(Exception e)
	 {
	 e.printStackTrace();
	 }
      }

   /*
   Called by the POSKybd class when a button is pressed
   */
   public void ButtonPressed(POSKybdButtonPressedEvent evt)
      {
      String numStr = "";
      int cnt,x,FCode;

      switch (evt.FCode)
	 {
	 case 900:
	    {
	    DoFileOp();
	    }
	    break;
	 case 901:
	    {
	    String tk1 = "B4387751111110^T/^05121010123456789";
	    String tk2 = "4718195055275=0505";
	    String tk3 = "B4387751111110^T/^05121010123456789";

	    Term.getMsr().SendMsrData(tk1,tk1.length(),tk2,tk2.length(),tk3,tk3.length());
	    }
	    break;
	 case 902:
	    {
	    CDIFileAccessor cfa = new CDIFileAccessor();
	    cfa.setUnitID(UnitID.intValue());
	    String s = cfa.GetCDIField("TS", "gtoreNum");
	    dbg.print("Store Num is " + s);
	    }
	    break;
	 default:
	    {			       /*				     */
				       /*				     */
	    Term.getIOProc().ExitAlphaEntryMode();
	    SendFCode(evt.FCode);
	    }
	    break;
	 }
      }

   public void SendFCode(int FCode)
      {
      dbg.print("Sending FCode " + FCode);
      Term.getKeyboard().SendKeyboardData(FCode);
      }

   private void jbInit() throws Exception
      {
      this.addWindowListener(new java.awt.event.WindowAdapter() {
	 public void windowClosing(WindowEvent e) {
	    this_windowClosing(e);
	 }
      });
      this.getContentPane().add(jPanel1, BorderLayout.CENTER);
      }

   void this_windowClosing(WindowEvent e)
      {
      System.exit(0);
      }

   /* RPAM Event handlers */
   public void Offline(OfflineEvent evt)
      {
      StatusMsg("Offline");
      };

   public void ConnectTimeout(ConnectTimeoutEvent evt)
      {
      StatusMsg("Connect attempt timed out");
      };

   public void Display(DisplayEvent evt) {};
   public void Print(PrintEvent evt) {};
   public void IOProcWait(IOProcWaitEvent evt)
      {
      dbg.print("IOP Wait " + state + " alpha " + alpha + " [" +
				    Term.getANDisplay().getRow1Text() + "][" +
				    Term.getANDisplay().getRow2Text() + "]");
      };

// public void IOProcErr(IOProcErrEvent evt) {};
   public void PrintEx(PrintExEvent evt)
      {

      if (evt.Station == CR)
	 {
	 if (evt.Command == CMD_PRINT_DATA)
	    {
	    /* regular print data */
	    ReceiptModel.addElement(ByteArrayToString(evt.Data, 0, evt.DataLen));
	    Receipt.setSelectedIndex(ReceiptModel.size()-1);
	    Receipt.ensureIndexIsVisible(ReceiptModel.size()-1);
	    }
	 else if (evt.Command == PARS46_CMDCODE_PRINT_LF)
	    {
	    /* line feed command, add blank line */
	    ReceiptModel.addElement("");
	    }
	 }
      else if ((evt.Station == DI) && (evt.Command == PARS46_CMDCODE_MICR_READ1B))
	 {
	 /* send an error every other time */
	 System.out.println("Sending micr data");
	 if ((exe_cnt % 2) != 0)
	    {
	    Term.getPrinter().SendMICRData("?", 0x8000000);
	    }
	 else
	    {
	    Term.getPrinter().SendMICRData("abcdefghij", 0);
	    }
	 exe_cnt++;
	 }
      };

   public void ActivateMICR(ActivateMICREvent evt)
      {
      System.out.println("Micr activated");
      Term.getPrinter().SendMICRData("T461004610T123456789A", 0);
      };

   public void Lock(LockEvent evt)
      {
      dbg.print("Lock() Event");
      };
   public void Unlock(UnlockEvent evt) {};
   public void ScannerUnlock(ScannerUnlockEvent evt) {};
   public void ScannerLock(ScannerLockEvent evt) {};
   public void Online(OnlineEvent evt)
      {
      Row1.setText("Terminal Online");
      Row2.setText("");
      StatusMsg("Online");
      };

   public void DisplayEx(DisplayExEvent evt)
      {
      if (evt.Device == 0)
	 {
	 Row1.setText(Term.getANDisplay().getRow1Text());
	 Row2.setText(Term.getANDisplay().getRow2Text());
	 switch(state)
	    {
	    case 2:
	    case 5:
	       break;
	    default:
	       dbg.print("DisplayEx() alpha " + alpha + " [" +
				    Term.getANDisplay().getRow1Text() + "][" +
				    Term.getANDisplay().getRow2Text() + "] state " + state);
	       break;
	    }
	 }
      };

   public void WaitLight(WaitLightEvent evt)
      {
      dbg.print("WaitLight() Event");
      };
   public void MessageLight(MessageLightEvent evt)
      {
      dbg.print("MessageLight() Event");
      };
   public void OfflineLight(OfflineLightEvent evt)
      {
      System.out.println("OfflineLight event " + evt.NewValue);
      };
   public void FieldLevelInput2(FieldLevelInput2Event evt)
      {
      lastState = state;
      state = evt.StateNum;
      alpha = evt.AlphaEntry;
      dbg.print("FieldLevelInput2() Event state=" + state + " lastState=" + lastState);
      };

   public void DrawerOpen(DrawerOpenEvent evt) {};
   public void FieldLevelInput(FieldLevelInputEvent evt)
      {
//    dbg.print("FieldLevelInput() Event");
      };
   public void MsrLock(MsrLockEvent evt) {};
   public void MsrUnlock(MsrUnlockEvent evt) {};
   public void IOProcErr(IOProcErrEvent evt)
      {
//    dbg.print("IOProcErr() Event");
      System.out.println("IOProc error event");
      };

   public void Tone(ToneEvent evt)
      {
      //System.out.println("Tone freq " + evt.Frequency + " dur " + evt.Duration);
      }

   static int call_num=0;

   public void ScaleRead(ScaleReadEvent evt)
      {
      Term.getScale().SendScaleData(0);
/*
      if (call_num == 0)
	 {
	 System.out.println("Sending 0 weight");
	 Term.getScale().SendScaleData(0);
	 }
      else
	 {
	 System.out.println("Sending 125 weight");
	 Term.getScale().SendScaleData(125);
	 }

      if (call_num == 1)
	 call_num = 0;
      else
	 call_num = 1;
*/
      };

   public void UserData(UserDataEvent evt)
      {
      };

   public void RunningTotalData(RunningTotalDataEvent evt) {};

   public void TotalsWrite(TotalsWriteEvent evt)
      {
      int x;
//    dbg.print("TotalsWrite Event len " + evt.Length + " offset " + evt.Offset + " 0x" + java.lang.Integer.toHexString(evt.Offset));
      for (x=0;x<evt.Length;x++)
	 {
	 totals[evt.Offset+x] = evt.Data[x];
	 }

      FlushTotalsFile();					     /* #04a */

      Term.getHardTotals().SendTotalsWriteResponse(evt.Length);
      }

   public void FlushTotalsFile()				     /* #04a[*/
      {
      try
	 {
	 totalsOut = new FileWriter(outputFile);
	 totStr = new String(totals);
	 totalsOut.write(totStr);
	 totalsOut.close();
	 }
      catch(Exception e)
	 {
	 }
      } 							     /* #04a]*/


   public void TotalsRead(TotalsReadEvent evt)
      {
      byte [] barr;
      int x;
//    dbg.print("TotalsRead Event len " + evt.Length + " offset " + evt.Offset + " 0x" + java.lang.Integer.toHexString(evt.Offset));

      barr = new byte[evt.Length];

      for (x=0; x<evt.Length;x++)
	 {
	 barr[x] = totals[evt.Offset+x];
	 }

      Term.getHardTotals().SendTotalsData(barr, evt.Length);
      };

   public void TermNumberChanged(TermNumberChangedEvent evt)
      {
      System.out.println("Term number has changed");
      };

   public void OfflineTotalsData(OfflineTotalsDataEvent evt) {};
   public void PrintEject(PrintEjectEvent evt) {};
   public void ReceiptCut(ReceiptCutEvent evt) {};
   public void TermIPLControl(TermIPLControlEvent evt) {};
   public void TermReload(TermReloadEvent evt) {};
   public void ActivateMarqueeDisplay(ActivateMarqueeDisplayEvent evt) {};
   public void DeactivateMarqueeDisplay(DeactivateMarqueeDisplayEvent evt) {};
   public void LoadMarqueeDisplay(LoadMarqueeDisplayEvent evt) {};

   /**************************************************************************/
   /* Event that gets fired when ANDisplay/ANDisplay2 filtering is turned on */
   /* and the app displays something on one of the displays		     */
   /**************************************************************************/
   public void PassiveANDisplayFilter(PassiveANDisplayFilterEvent evt)
      {
      if (evt.Device == 0)
	 {
	 Row1.setText(Term.getANDisplay().getRow1Text());
	 Row2.setText(Term.getANDisplay().getRow2Text());
	 }
//    dbg.print("PassiveANDisplayFilter");
      }

   /**************************************************************************/
   /* Future								     */
   /**************************************************************************/
   public void PassiveJavaCallFilter(PassiveJavaCallFilterEvent evt)
      {
//    dbg.print("PassiveJavaCallFilter");
      }

   /**************************************************************************/
   /* Future								     */
   /**************************************************************************/
   public void PassiveMSRFilter(PassiveMSRFilterEvent evt)
      {
//    dbg.print("PassiveMSRFilter");
      }

   /**************************************************************************/
   /* Event that gets fired when Printer filtering is turned on the app      */
   /* reads or writes to the printer					     */
   /**************************************************************************/
   public void PassivePrinterFilter(PassivePrinterFilterEvent evt)
      {
      String act;
      if (evt.Action == rpaFilterActionRead)
	 {
	 act = "READ";
	 }
      else if (evt.Action == rpaFilterActionWrite)
	 {
	 act = "WRITE";
	 }
      else
	 {
	 act = "???";
	 }

      String stat;
      if (evt.Station == rpaCRStation)
	 {
	 stat = "CR";
	 }
      else if (evt.Station == rpaDIStation)
	 {
	 stat = "DI";
	 }
      else if (evt.Station == rpaSJStation)
	 {
	 stat = "SJ";
	 }
      else
	 {
	 stat = "??";
	 }

//    dbg.print("PrinterFilter Action:" + act + " Station:" + stat +
//		     " Cmd: 0x" + java.lang.Integer.toHexString(evt.Command) +
//						      " LF: " + evt.LineFeeds);
//    dbg.hexlog(evt.Data, "filterdata");
      }

   /**************************************************************************/
   /* Event that gets fired when Serial filtering is turned on the app	     */
   /* reads or writes to the printer					     */
   /**************************************************************************/
   public void PassiveSerialFilter(PassiveSerialFilterEvent evt)
      {

      String act;
      if (evt.Action == rpaFilterActionRead)
	 {
	 act = "READ";
	 }
      else if (evt.Action == rpaFilterActionWrite)
	 {
	 act = "WRITE";
	 }
      else
	 {
	 act = "???";
	 }

//    dbg.print("SerialFilter Action:" + act + " Port:" + evt.Port );
//    dbg.hexlog(evt.Data, "filterdata");
      }

   public String ByteArrayToString(byte[] arr, int start, int len)
      {
      String RetVal = "";
      int i;
      for (i=start;i<start+len;i++)
	 {
	 RetVal = RetVal + (char)arr[i];
	 }
      return RetVal;
      }
      class SerialEventHandler implements qvs.SerialEventListener
      {
      int Port;

      public SerialEventHandler(int pPort)
	 {
	 Port = pPort;
	 }

      public void Open(SerialOpenEvent evt)
	 {
	 int GetLongVal;
	 System.out.println("Serial open for port " + Port);
	 System.out.println("Baud " + evt.Speed + " Parity " + evt.Parity);
	 System.out.println("DBits " + evt.DataBits + " SBits " + evt.StopBits);
	 System.out.println("Buffer size " + evt.BuffSize);

				       /* send a good open return code	     */
				       /* and send a getlong status update   */
				       /* to TC.  Note: the only bits that   */
				       /* may be set in a getlong from the   */
				       /* client are the ones shown here     */
	 GetLongVal = s1DataLost | s2DSRActive | s2CTSActive | s2ParityError |
					     s2FramingError | s2BreakDetected;

	 if (Port == 1)
	    {
	    Term.getSerial1().SendOpenRc(0);
	    Term.getSerial1().UpdatePortStatus(GetLongVal);
	    }
	 else if (Port == 2)
	    {
	    Term.getSerial2().SendOpenRc(0);
	    Term.getSerial2().UpdatePortStatus(GetLongVal);
	    }
	 else if (Port == 3)
	    {
	    Term.getSerial3().SendOpenRc(0);
	    Term.getSerial3().UpdatePortStatus(GetLongVal);
	    }
	 else if (Port == 4)
	    {
	    Term.getSerial4().SendOpenRc(0);
	    Term.getSerial4().UpdatePortStatus(GetLongVal);
	    }
	 }

      public void PutLong(SerialPutLongEvent evt)
	 {
	 System.out.println( "PutLong on port " + Port + " Timeout " +
				  evt.TimeOut + " Stat " + evt.PortStatusInfo);

				       /* send a good  return code back to   */
				       /* the .286			     */
	 POSSerialDevice dev = (POSSerialDevice)(evt.getSource());
//	   dev.SendPutLongRc((evt.TimeOut << 24) + (evt.PortStatusInfo << 16) + 0x26);
	 dev.SendPutLongRc(0);
	 }

      public void Write(SerialWriteEvent evt)
	 {
	 System.out.println("Serial write for port " +
				    Port + "len is " + evt.Length + " bytes.");

	 String StrData = ByteArrToString(evt.Data,0,evt.Length);
	 System.out.println("[" + StrData + "]" );

				       /* give an rc back for the number of  */
				       /* bytes written 		     */
	 POSSerialDevice dev = (POSSerialDevice)(evt.getSource());
	 dev.SendWriteRc(evt.Length);

	 }

      public void Close(SerialCloseEvent evt)
	 {
	 System.out.println("Close for port " + Port);
	 }
      }


				       /* VDISPLAY event handlers	     */
   public void CursorVisibilityChange(CursorVisibilityChangeEvent evt)
      {
      POSVDisplay vd = Term.getVDisplay();
      System.out.println("CursorVisibilityChange, cursor is " + evt.CursorVisible);

      if (FirstVDispEventReceived == 0)
	 {
	 /*
	 After the first VDISPLAY event, the properties of the
	 object are available, read them now
	 */

	 System.out.println("fmt: " + vd.DisplayFormat);
	 System.out.println("cur: " + vd.CursorVisible);
	 System.out.println("undl: " + vd.VGAUnderlining);
	 System.out.println("intens: " + vd.VGAIntensifyBackground);
	 System.out.println("attrtype: " + vd.AttributeType);
	 System.out.println("curr attr: " + vd.CurrentAttribute);
	 System.out.println("disptype: " + vd.DisplayType);
	 FirstVDispEventReceived = 1;
	 }
      }

   public void DisplayFormatChange(DisplayFormatChangeEvent evt)
      {
      System.out.println("DisplayFormatChange, fmt is " + evt.DisplayFormat);
      }
   public void Display(VDisplayEvent evt)
      {
      System.out.println("VDisplay len " + evt.Length + " flg " + evt.Flags + " row " + evt.Row + " col " + evt.Col);
      System.out.println("[" + evt.Text + "]");
      }
   }


class POSKybdButtonPressedEvent extends EventObject
   {
   public int FCode;
   public String barcodeLabelType;
   public String input;

   public POSKybdButtonPressedEvent(Object source, int FC)
      {
      super(source);
      FCode = FC;
      }
   }

interface POSKybdListener extends java.util.EventListener
   {
   public void ButtonPressed(POSKybdButtonPressedEvent evt);
   }


class QButton extends JButton
   {
   public int FCode;
   public String barcodeLabelType;
   public String input;
   }

class POSKybd extends JPanel implements ActionListener
   {
   public String prefix;
   Vector Listeners = new Vector();
   QButton Button0;
   QButton Button1;
   QButton Button2;
   QButton Button3;
   QButton Button4;
   QButton Button5;
   QButton Button6;
   QButton Button7;
   QButton Button8;
   QButton Button9;
   QButton ButtonSlash;

   QButton ButtonS1;
   QButton ButtonS2;

   QButton ButtonK1;
   QButton ButtonK2;
   QButton ButtonK3;
   QButton ButtonK4;
   QButton ButtonK5;
   QButton ButtonK6;
   QButton ButtonK7;
   QButton ButtonK8;
   QButton ButtonK9;
   QButton ButtonK10;
   QButton ButtonK11;
   QButton ButtonK12;
   QButton ButtonK13;
   QButton ButtonK14;
   QButton ButtonK15;
   QButton ButtonK16;
   QButton ButtonK17;
   QButton ButtonK18;
   QButton ButtonK19;
   QButton ButtonK20;
   QButton ButtonK21;
   QButton ButtonK22;
   QButton ButtonK23;
   QButton ButtonK24;
   QButton ButtonK25;
   QButton ButtonK26;
   QButton ButtonK27;
   QButton ButtonK28;
   QButton ButtonK29;
   QButton ButtonK30;
   QButton ButtonK31;
   QButton ButtonK32;
   QButton ButtonK33;
   QButton ButtonK34;
   QButton ButtonK35;
   QButton ButtonK36;
   QButton ButtonK37;

   public int gCodeMode=0;
   String CodeString="";

   public void actionPerformed(ActionEvent e)
      {
      int TempInt=0;
      int x;
      QButton btn = (QButton)(e.getSource());
//    System.out.println("actionPerformed() entry");
      if (gCodeMode == 1)
	 {
	 if ((btn.FCode == 80 ||
	     btn.FCode == 95) && (CodeString.length() > 0))
	    {
	    for(x=0;x<CodeString.length();x++)
	       {
	       TempInt = (TempInt * 10) + (int)(CodeString.charAt(x)-0x30);
       //	 System.out.println("TempInt "+ TempInt);
	       }

	    FireEvent(TempInt);

	    CodeString = "";
	    }
	 else if (btn.FCode >= 48 && btn.FCode <= 57)
	    {
	    CodeString = CodeString + (char)btn.FCode;
	 //   System.out.println("CodeString " + CodeString);
	    }
	 }
      else
	 {
	 FireEvent(btn.FCode);
	 }
//    System.out.println("actionPerformed() exit");
      }

   public POSKybd()
      {
      Properties p = new Properties();
      String prop_name;
      String prop_val;
      int prop_val_int;
      int i;

      setLayout(null);
      int bWidth  = 880;
      int bHeight = 205;
      setBounds(5,110,bWidth,bHeight);

      // ********************************************************
      // Numeric pad
      // ********************************************************
      int x = 270;
      Button7 = new QButton();
      this.add(Button7);
      Button7.setBorder(BorderFactory.createRaisedBevelBorder());
      Button7.setBounds(x,40,40,40);
      Button7.addActionListener(this);

      Button4 = new QButton();
      this.add(Button4);
      Button4.setBorder(BorderFactory.createRaisedBevelBorder());
      Button4.setBounds(x,80,40,40);
      Button4.addActionListener(this);

      Button1 = new QButton();
      this.add(Button1);
      Button1.setBorder(BorderFactory.createRaisedBevelBorder());
      Button1.setBounds(x,120,40,40);
      Button1.addActionListener(this);

      Button0 = new QButton();
      this.add(Button0);
      Button0.setBorder(BorderFactory.createRaisedBevelBorder());
      Button0.setBounds(x,160,80,40);
      Button0.addActionListener(this);

      x += 40;
      Button8 = new QButton();
      this.add(Button8);
      Button8.setBorder(BorderFactory.createRaisedBevelBorder());
      Button8.setBounds(x,40,40,40);
      Button8.addActionListener(this);

      Button5 = new QButton();
      this.add(Button5);
      Button5.setBorder(BorderFactory.createRaisedBevelBorder());
      Button5.setBounds(x,80,40,40);
      Button5.addActionListener(this);

      Button2 = new QButton();
      this.add(Button2);
      Button2.setBorder(BorderFactory.createRaisedBevelBorder());
      Button2.setBounds(x,120,40,40);
      Button2.addActionListener(this);

      x += 40;
      Button9 = new QButton();
      this.add(Button9);
      Button9.setBorder(BorderFactory.createRaisedBevelBorder());
      Button9.setBounds(x,40,40,40);
      Button9.addActionListener(this);

      Button6 = new QButton();
      this.add(Button6);
      Button6.setBorder(BorderFactory.createRaisedBevelBorder());
      Button6.setBounds(x,80,40,40);
      Button6.addActionListener(this);

      Button3 = new QButton();
      this.add(Button3);
      Button3.setBorder(BorderFactory.createRaisedBevelBorder());
      Button3.setBounds(x,120,40,40);
      Button3.addActionListener(this);

      ButtonSlash = new QButton();
      this.add(ButtonSlash);
      ButtonSlash.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonSlash.setBounds(x,160,40,40);
      ButtonSlash.addActionListener(this);
      // ********************************************************
      // Column 1
      // ********************************************************
      x = 0;
      ButtonK1 = new QButton();
      this.add(ButtonK1);
      ButtonK1.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK1.setBounds(x,0,80,40);
      ButtonK1.addActionListener(this);

      ButtonK2 = new QButton();
      this.add(ButtonK2);
      ButtonK2.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK2.setBounds(x,40,80,40);
      ButtonK2.addActionListener(this);

      ButtonK3 = new QButton();
      this.add(ButtonK3);
      ButtonK3.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK3.setBounds(x,80,80,40);
      ButtonK3.addActionListener(this);

      ButtonK4 = new QButton();
      this.add(ButtonK4);
      ButtonK4.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK4.setBounds(x,120,80,40);
      ButtonK4.addActionListener(this);

      ButtonK5 = new QButton();
      this.add(ButtonK5);
      ButtonK5.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK5.setBounds(x,160,80,40);
      ButtonK5.addActionListener(this);

      // ********************************************************
      // Column 2
      // ********************************************************
      x += 80;
      ButtonK6 = new QButton();
      this.add(ButtonK6);
      ButtonK6.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK6.setBounds(x,0,80,40);
      ButtonK6.addActionListener(this);

      ButtonK7 = new QButton();
      this.add(ButtonK7);
      ButtonK7.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK7.setBounds(x,40,80,40);
      ButtonK7.addActionListener(this);

      ButtonK8 = new QButton();
      this.add(ButtonK8);
      ButtonK8.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK8.setBounds(x,80,80,40);
      ButtonK8.addActionListener(this);

      ButtonK9 = new QButton();
      this.add(ButtonK9);
      ButtonK9.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK9.setBounds(x,120,80,40);
      ButtonK9.addActionListener(this);

      ButtonK10 = new QButton();
      this.add(ButtonK10);
      ButtonK10.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK10.setBounds(x,160,80,40);
      ButtonK10.addActionListener(this);

      // ********************************************************
      // Column 3
      // ********************************************************
      x += 80;
      ButtonK11 = new QButton();
      this.add(ButtonK11);
      ButtonK11.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK11.setBounds(x,0,80,40);
      ButtonK11.addActionListener(this);

      ButtonK12 = new QButton();
      this.add(ButtonK12);
      ButtonK12.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK12.setBounds(x,40,80,40);
      ButtonK12.addActionListener(this);

      ButtonK13 = new QButton();
      this.add(ButtonK13);
      ButtonK13.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK13.setBounds(x,80,80,40);
      ButtonK13.addActionListener(this);

      ButtonK14 = new QButton();
      this.add(ButtonK14);
      ButtonK14.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK14.setBounds(x,120,80,40);
      ButtonK14.addActionListener(this);

      ButtonK15 = new QButton();
      this.add(ButtonK15);
      ButtonK15.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK15.setBounds(x,160,80,40);
      ButtonK15.addActionListener(this);

      // ********************************************************
      // Column 3a
      // ********************************************************
      x += 90;
      ButtonK16 = new QButton();
      this.add(ButtonK16);
      ButtonK16.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK16.setBounds(x,0,80,40);
      ButtonK16.addActionListener(this);

      x += 80;
      ButtonK17 = new QButton();
      this.add(ButtonK17);
      ButtonK17.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK17.setBounds(x,0,80,40);
      ButtonK17.addActionListener(this);

      // ********************************************************
      // Column 4
      // ********************************************************
      x = 420;
      ButtonK18 = new QButton();
      this.add(ButtonK18);
      ButtonK18.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK18.setBounds(x,0,80,40);
      ButtonK18.addActionListener(this);

      ButtonK19 = new QButton();
      this.add(ButtonK19);
      ButtonK19.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK19.setBounds(x,40,80,40);
      ButtonK19.addActionListener(this);

      ButtonK20 = new QButton();
      this.add(ButtonK20);
      ButtonK20.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK20.setBounds(x,80,80,40);
      ButtonK20.addActionListener(this);

      ButtonK21 = new QButton();
      this.add(ButtonK21);
      ButtonK21.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK21.setBounds(x,120,80,40);
      ButtonK21.addActionListener(this);

      ButtonK22 = new QButton();
      this.add(ButtonK22);
      ButtonK22.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK22.setBounds(x,160,80,40);
      ButtonK22.addActionListener(this);

      // ********************************************************
      // Column 5
      // ********************************************************
      x += 80;
      ButtonK23= new QButton();
      this.add(ButtonK23);
      ButtonK23.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK23.setBounds(x,0,80,40);
      ButtonK23.addActionListener(this);

      ButtonK24 = new QButton();
      this.add(ButtonK24);
      ButtonK24.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK24.setBounds(x,40,80,40);
      ButtonK24.addActionListener(this);

      ButtonK25 = new QButton();
      this.add(ButtonK25);
      ButtonK25.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK25.setBounds(x,80,80,40);
      ButtonK25.addActionListener(this);

      ButtonK26 = new QButton();
      this.add(ButtonK26);
      ButtonK26.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK26.setBounds(x,120,80,40);
      ButtonK26.addActionListener(this);

      ButtonK27 = new QButton();
      this.add(ButtonK27);
      ButtonK27.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK27.setBounds(x,160,80,40);
      ButtonK27.addActionListener(this);

      // ********************************************************
      // Column 6
      // ********************************************************
      x += 80;
      ButtonK28 = new QButton();
      this.add(ButtonK28);
      ButtonK28.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK28.setBounds(x,0,80,40);
      ButtonK28.addActionListener(this);

      ButtonK29 = new QButton();
      this.add(ButtonK29);
      ButtonK29.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK29.setBounds(x,40,80,40);
      ButtonK29.addActionListener(this);

      ButtonK30 = new QButton();
      this.add(ButtonK30);
      ButtonK30.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK30.setBounds(x,80,80,40);
      ButtonK30.addActionListener(this);

      ButtonK31 = new QButton();
      this.add(ButtonK31);
      ButtonK31.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK31.setBounds(x,120,80,40);
      ButtonK31.addActionListener(this);

      ButtonK32 = new QButton();
      this.add(ButtonK32);
      ButtonK32.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK32.setBounds(x,160,80,40);
      ButtonK32.addActionListener(this);
      // ********************************************************
      // Column 7
      // ********************************************************
      x += 80;
      ButtonK33 = new QButton();
      this.add(ButtonK33);
      ButtonK33.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK33.setBounds(x,0,80,40);
      ButtonK33.addActionListener(this);

      ButtonK34 = new QButton();
      this.add(ButtonK34);
      ButtonK34.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK34.setBounds(x,40,80,40);
      ButtonK34.addActionListener(this);

      ButtonK35 = new QButton();
      this.add(ButtonK35);
      ButtonK35.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK35.setBounds(x,80,80,40);
      ButtonK35.addActionListener(this);

      ButtonK36 = new QButton();
      this.add(ButtonK36);
      ButtonK36.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK36.setBounds(x,120,80,40);
      ButtonK36.addActionListener(this);

      ButtonK37 = new QButton();
      this.add(ButtonK37);
      ButtonK37.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonK37.setBounds(x,160,80,40);
      ButtonK37.addActionListener(this);
      // ********************************************************
      // System function keys
      // ********************************************************
      x += 100;
      ButtonS1 = new QButton();
      this.add(ButtonS1);
      ButtonS1.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonS1.setBounds(x,0,80,40);
      ButtonS1.setText("S1");
      ButtonS1.addActionListener(this);
      ButtonS1.FCode=1;

      ButtonS2 = new QButton();
      this.add(ButtonS2);
      ButtonS2.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonS2.setBounds(x,40,80,40);
      ButtonS2.setText("S2");
      ButtonS2.addActionListener(this);
      ButtonS2.FCode=2;

      try
	 {
	 p.load(new FileInputStream("keymap.pro"));
	 }
      catch (Exception e)
	 {
	 System.out.println("Unable to load keymap file keymap.pro");
	 System.exit(1);
	 }

      prefix = p.getProperty("Prefix");

      if (prefix.length() > 0)
	 {
	 prefix = prefix + ".";
	 }

      try
	 {
	 prop_name = prefix + "Button0.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val != null)
	    {
	    System.out.println("[" + prop_val + "]");
	    prop_val_int = new Integer(prop_val).intValue();
	    Button0.FCode = prop_val_int;
	    prop_name = prefix + "Button0.Text";
	    prop_val = p.getProperty(prop_name);
	    Button0.setText(prop_val);
	    prop_name = prefix + "Button0.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       Button0.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "Button1.FCode";
	 prop_val = p.getProperty(prop_name);
	 prop_val_int = new Integer(prop_val).intValue();
	 Button1.FCode = prop_val_int;
	 prop_name = prefix + "Button1.Text";
	 prop_val = p.getProperty(prop_name);
	 Button1.setText(prop_val);
	 prop_name = prefix + "Button1.Mnemonic";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() == 1)
	    Button1.setMnemonic(prop_val.charAt(0));

	 prop_name = prefix + "Button2.FCode";
	 prop_val = p.getProperty(prop_name);
	 prop_val_int = new Integer(prop_val).intValue();
	 Button2.FCode = prop_val_int;
	 prop_name = prefix + "Button2.Text";
	 prop_val = p.getProperty(prop_name);
	 Button2.setText(prop_val);
	 prop_name = prefix + "Button2.Mnemonic";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() == 1)
	    Button2.setMnemonic(prop_val.charAt(0));

	 prop_name = prefix + "Button3.FCode";
	 prop_val = p.getProperty(prop_name);
	 prop_val_int = new Integer(prop_val).intValue();
	 Button3.FCode = prop_val_int;
	 prop_name = prefix + "Button3.Text";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() == 1)
	    Button3.setText(prop_val);
	 prop_name = prefix + "Button3.Mnemonic";
	 prop_val = p.getProperty(prop_name);
	 Button3.setMnemonic(prop_val.charAt(0));

	 prop_name = prefix + "Button4.FCode";
	 prop_val = p.getProperty(prop_name);
	 prop_val_int = new Integer(prop_val).intValue();
	 Button4.FCode = prop_val_int;
	 prop_name = prefix + "Button4.Text";
	 prop_val = p.getProperty(prop_name);
	 Button4.setText(prop_val);
	 prop_name = prefix + "Button4.Mnemonic";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() == 1)
	    Button4.setMnemonic(prop_val.charAt(0));

	 prop_name = prefix + "Button5.FCode";
	 prop_val = p.getProperty(prop_name);
	 prop_val_int = new Integer(prop_val).intValue();
	 Button5.FCode = prop_val_int;
	 prop_name = prefix + "Button5.Text";
	 prop_val = p.getProperty(prop_name);
	 Button5.setText(prop_val);
	 prop_name = prefix + "Button5.Mnemonic";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() == 1)
	    Button5.setMnemonic(prop_val.charAt(0));

	 prop_name = prefix + "Button6.FCode";
	 prop_val = p.getProperty(prop_name);
	 prop_val_int = new Integer(prop_val).intValue();
	 Button6.FCode = prop_val_int;
	 prop_name = prefix + "Button6.Text";
	 prop_val = p.getProperty(prop_name);
	 Button6.setText(prop_val);
	 prop_name = prefix + "Button6.Mnemonic";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() == 1)
	    Button6.setMnemonic(prop_val.charAt(0));

	 prop_name = prefix + "Button7.FCode";
	 prop_val = p.getProperty(prop_name);
	 prop_val_int = new Integer(prop_val).intValue();
	 Button7.FCode = prop_val_int;
	 prop_name = prefix + "Button7.Text";
	 prop_val = p.getProperty(prop_name);
	 Button7.setText(prop_val);
	 prop_name = prefix + "Button7.Mnemonic";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() == 1)
	    Button7.setMnemonic(prop_val.charAt(0));

	 prop_name = prefix + "Button8.FCode";
	 prop_val = p.getProperty(prop_name);
	 prop_val_int = new Integer(prop_val).intValue();
	 Button8.FCode = prop_val_int;
	 prop_name = prefix + "Button8.Text";
	 prop_val = p.getProperty(prop_name);
	 Button8.setText(prop_val);
	 prop_name = prefix + "Button8.Mnemonic";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() == 1)
	    Button8.setMnemonic(prop_val.charAt(0));

	 prop_name = prefix + "Button9.FCode";
	 prop_val = p.getProperty(prop_name);
	 prop_val_int = new Integer(prop_val).intValue();
	 Button9.FCode = prop_val_int;
	 prop_name = prefix + "Button9.Text";
	 prop_val = p.getProperty(prop_name);
	 Button9.setText(prop_val);
	 prop_name = prefix + "Button9.Mnemonic";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() == 1)
	    Button9.setMnemonic(prop_val.charAt(0));

	 prop_name = prefix + "ButtonSlash.FCode";
	 prop_val = p.getProperty(prop_name);
	 prop_val_int = new Integer(prop_val).intValue();
	 ButtonSlash.FCode = prop_val_int;
	 prop_name = prefix + "ButtonSlash.Text";
	 prop_val = p.getProperty(prop_name);
	 ButtonSlash.setText(prop_val);
	 prop_name = prefix + "ButtonSlash.Mnemonic";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() == 1)
	    ButtonSlash.setMnemonic(prop_val.charAt(0));
	 // ********************************************************
	 // Column 1
	 // ********************************************************
	 prop_name = prefix + "ButtonK1.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK1.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK1.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK1.setText(prop_val);
	    prop_name = prefix + "ButtonK1.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK1.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK2.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK2.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK2.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK2.setText(prop_val);
	    prop_name = prefix + "ButtonK2.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK2.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK3.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK3.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK3.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK3.setText(prop_val);
	    prop_name = prefix + "ButtonK3.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK3.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK4.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK4.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK4.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK4.setText(prop_val);
	    prop_name = prefix + "ButtonK4.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK4.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK5.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK5.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK5.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK5.setText(prop_val);
	    prop_name = prefix + "ButtonK5.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK5.setMnemonic(prop_val.charAt(0));
	    }
	 // ********************************************************
	 // Column 2
	 // ********************************************************
	 prop_name = prefix + "ButtonK6.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK6.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK6.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK6.setText(prop_val);
	    prop_name = prefix + "ButtonK6.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK6.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK7.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK7.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK7.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK7.setText(prop_val);
	    prop_name = prefix + "ButtonK7.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK7.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK8.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK8.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK8.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK8.setText(prop_val);
	    prop_name = prefix + "ButtonK8.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK8.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK9.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK9.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK9.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK9.setText(prop_val);
	    prop_name = prefix + "ButtonK9.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK9.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK10.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK10.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK10.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK10.setText(prop_val);
	    prop_name = prefix + "ButtonK10.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK10.setMnemonic(prop_val.charAt(0));
	    }
	 // ********************************************************
	 // Column 3
	 // ********************************************************
	 prop_name = prefix + "ButtonK11.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK11.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK11.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK11.setText(prop_val);
	    prop_name = prefix + "ButtonK11.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK11.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK12.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK12.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK12.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK12.setText(prop_val);
	    prop_name = prefix + "ButtonK12.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK12.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK13.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK13.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK13.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK13.setText(prop_val);
	    prop_name = prefix + "ButtonK13.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK13.setMnemonic(prop_val.charAt(0));
	    prop_name = prefix + "ButtonK13.Input";
	    prop_val = p.getProperty(prop_name);
	    ButtonK13.input = prop_val;
	    prop_name = prefix + "ButtonK13.BarcodeLabel";
	    prop_val = p.getProperty(prop_name);
	    ButtonK13.barcodeLabelType = prop_val;
	    }

	 prop_name = prefix + "ButtonK14.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK14.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK14.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK14.setText(prop_val);
	    prop_name = prefix + "ButtonK14.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK14.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK15.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK15.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK15.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK15.setText(prop_val);
	    prop_name = prefix + "ButtonK15.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK15.setMnemonic(prop_val.charAt(0));
	    }
	 // ********************************************************
	 // Column 3a
	 // ********************************************************
	 ButtonK16.setText(prop_val);
	 prop_name = prefix + "ButtonK16.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK16.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK16.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK16.setText(prop_val);
	    prop_name = prefix + "ButtonK16.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK16.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK17.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK17.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK17.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK17.setText(prop_val);
	    prop_name = prefix + "ButtonK17.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK17.setMnemonic(prop_val.charAt(0));
	    }
	 // ********************************************************
	 // Column 4
	 // ********************************************************
	 prop_name = prefix + "ButtonK18.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK18.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK18.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK18.setText(prop_val);
	    prop_name = prefix + "ButtonK18.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK18.setMnemonic(prop_val.charAt(0));
	    prop_name = prefix + "ButtonK18.Input";
	    prop_val = p.getProperty(prop_name);
	    ButtonK18.input = prop_val;
	    prop_name = prefix + "ButtonK18.BarcodeLabel";
	    prop_val = p.getProperty(prop_name);
	    ButtonK18.barcodeLabelType = prop_val;
	    }

	 prop_name = prefix + "ButtonK19.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK19.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK19.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK19.setText(prop_val);
	    prop_name = prefix + "ButtonK19.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	    ButtonK19.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK20.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK20.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK20.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK20.setText(prop_val);
	    prop_name = prefix + "ButtonK20.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK20.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK21.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK21.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK21.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK21.setText(prop_val);
	    prop_name = prefix + "ButtonK21.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK21.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK22.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK22.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK22.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK22.setText(prop_val);
	    prop_name = prefix + "ButtonK22.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK22.setMnemonic(prop_val.charAt(0));
	    }

	 // ********************************************************
	 // Column 5
	 // ********************************************************
	 prop_name = prefix + "ButtonK23.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK23.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK23.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK23.setText(prop_val);
	    prop_name = prefix + "ButtonK23.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK23.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK24.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK24.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK24.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK24.setText(prop_val);
	    prop_name = prefix + "ButtonK24.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK24.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK25.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK25.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK25.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK25.setText(prop_val);
	    prop_name = prefix + "ButtonK25.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK25.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK26.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK26.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK26.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK26.setText(prop_val);
	    prop_name = prefix + "ButtonK26.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK26.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK27.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK27.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK27.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK27.setText(prop_val);
	    prop_name = prefix + "ButtonK27.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK27.setMnemonic(prop_val.charAt(0));
	    }

	 // ********************************************************
	 // Column 6
	 // ********************************************************
	 prop_name = prefix + "ButtonK28.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK28.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK28.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK28.setText(prop_val);
	    prop_name = prefix + "ButtonK28.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK28.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK29.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK29.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK29.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK29.setText(prop_val);
	    prop_name = prefix + "ButtonK29.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK29.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK30.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK30.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK30.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK30.setText(prop_val);
	    prop_name = prefix + "ButtonK30.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK30.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK31.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK31.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK31.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK31.setText(prop_val);
	    prop_name = prefix + "ButtonK31.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK31.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK32.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK32.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK32.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK32.setText(prop_val);
	    prop_name = prefix + "ButtonK32.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK32.setMnemonic(prop_val.charAt(0));
	    }

	 // ********************************************************
	 // Column 7
	 // ********************************************************
	 prop_name = prefix + "ButtonK33.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK33.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK33.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK33.setText(prop_val);
	    prop_name = prefix + "ButtonK33.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK33.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK34.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK34.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK34.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK34.setText(prop_val);
	    prop_name = prefix + "ButtonK34.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK34.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK35.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK35.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK35.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK35.setText(prop_val);
	    prop_name = prefix + "ButtonK35.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK35.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK36.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK36.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK36.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK36.setText(prop_val);
	    prop_name = prefix + "ButtonK36.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK36.setMnemonic(prop_val.charAt(0));
	    }

	 prop_name = prefix + "ButtonK37.FCode";
	 prop_val = p.getProperty(prop_name);
	 if (prop_val.length() != 0)
	    {
	    prop_val_int = new Integer(prop_val).intValue();
	    ButtonK37.FCode = prop_val_int;
	    prop_name = prefix + "ButtonK37.Text";
	    prop_val = p.getProperty(prop_name);
	    ButtonK37.setText(prop_val);
	    prop_name = prefix + "ButtonK37.Mnemonic";
	    prop_val = p.getProperty(prop_name);
	    if (prop_val.length() == 1)
	       ButtonK37.setMnemonic(prop_val.charAt(0));
	    }

	 }
      catch (Exception e)
	 {
	 System.out.println("Exception processing keymap.pro");
	 System.out.println("Entries are case sensitive!!");
	 System.out.println("");

	 e.printStackTrace();
	 }

      setVisible(true);
      }

   public synchronized void addPOSKybdListener(POSKybdListener listener)
      {
      if (!Listeners.contains(listener))
	 {
	 Listeners.addElement(listener);
	 }
      }

   public synchronized void removePOSKybdListener(POSKybdListener listener)
      {
      if (Listeners.contains(listener))
	 {
	 Listeners.removeElement(listener);
	 }
      }

   private void FireEvent(int FCode)
      {
      Vector v;

      synchronized(this)
	 {
	 v = (Vector) Listeners.clone();
	 }

      int cnt = v.size();

      for (int i=0; i<cnt; i++)
	 {
	 POSKybdListener Listener = (POSKybdListener)v.elementAt(i);
	 POSKybdButtonPressedEvent evt =
				    new POSKybdButtonPressedEvent(this, FCode);
	 Listener.ButtonPressed(evt);
	 }
      }
   }
