package javasamp;

import java.awt.*;
import java.util.*;
import java.util.Vector;

import qvs.*;
import qvs.RPAMEventListener;
import qvs.RPAMEvents.*;
import qvs.RPAMDevices.*;

import qvs.RPAMApp;
import qvs.RPAMTerminal;
import qvs.RPAMDevices.POSDisplay;
import java.awt.event.*;
import javax.swing.*;

import java.io.*;
import java.util.Properties;

public class MainForm extends JDialog implements qvs.RPAMEventListenerEx, qvs.RPAMGlobals,
                                             POSKybdListener,
                                             VDisplayEventListener
   {
   RPAMTerminal Term;
   RPAMApp App;
   Integer TermNum;
   Integer UnitID;
   Integer StoreNum;
   SerialEventHandler Serial1Handler;  /* an instance of the SerialEvent     */
   SerialEventHandler Serial2Handler;  /* an instance of the SerialEvent     */
   static int FirstVDispEventReceived = 0;
   int m_EnableVDisplay=0;
   int m_AutoConnectEnabled=0;
   int AppHardTotals=0;
   String TCAddr;
   byte [] totals;
   File inputFile = new File("totals.txt");
   File outputFile = new File("totals.txt");
   FileReader totalsIn;
   FileWriter totalsOut;
   String totStr;

   JTextField Row1;
   JTextField Row2;
   JTextField UnitEdit;
   JTextField TermEdit;
   JLabel UnitLabel;
   JLabel TermLabel;
   JCheckBox  Connect;
   JCheckBox  MgrKey;
   JButton StartBtn;
   POSKybd Keyboard;

   JScrollPane ScrlPane;
   JList Receipt;
   DefaultListModel ReceiptModel;
   String CodeString = "";

   JCheckBox  EnableVDisplay;
   JCheckBox  EnableSerial1;
   JCheckBox  EnableSerial2;
   JCheckBox  Enable4610;

   JPanel jPanel1 = new JPanel();
   JCheckBox  CodeMode;
   JCheckBox  DIDocPresent;
   static int exe_cnt = 0;

   public MainForm()
      {
      Init("","", 0, 0, 0, "");
      }

   public MainForm(String TermNum, String StoreNum, int pEnableVDisplay, int pAutoConnectEnabled, int AppHardTotals, String TCAddr)
      {
      Init(TermNum, StoreNum, pEnableVDisplay, pAutoConnectEnabled, AppHardTotals, TCAddr);
      }

   public String ByteArrToString(byte[] arr, int start, int len)
      {
      String RetVal = "";
      int i;
      for (i=start;i<start+len;i++)
         {
         RetVal = RetVal + (char)arr[i];
         }
      return RetVal;
      }

   public byte[] StringToByteArr(String str)
      {
      int Len = str.length();
      byte[] RetVal = new byte[Len];
      int i;
      for (i=0;i<Len;i++)
         {
         RetVal[i] = (byte)(str.charAt(i));
         }
      return RetVal;

      }

    public void Init(String TermNum, String StoreNum, int pEnableVDisplay, int pAutoConnectEnabled, int AppHardTotals, String TCAddr)
      {
      int ANDHeight = 23;
      int ANDWidth = 285;
      int ANDX = 5;
      int ANDY = 50;
      int x;

      if (TermNum.length() == 0)
         {
         TermNum = "1";
         }

      if (StoreNum.length() == 0)
         {
         StoreNum = "0";
         }

      this.TermNum = new Integer(TermNum);
      this.StoreNum = new Integer(StoreNum);
      this.UnitID = new Integer(1);
      this.TCAddr = TCAddr;
      m_EnableVDisplay = pEnableVDisplay;
      m_AutoConnectEnabled = pAutoConnectEnabled;
      this.AppHardTotals = AppHardTotals;

      Serial1Handler = new SerialEventHandler(1);
      Serial2Handler = new SerialEventHandler(2);

      try
         {
         jbInit();
         }
      catch(Exception e)
         {
         e.printStackTrace();
         }

      setBounds(100,100,350,560);
      getContentPane().setLayout(null);

      Row1 = new JTextField();
      getContentPane().add(Row1);
      Row1.setBounds(ANDX,ANDY,ANDWidth,ANDHeight);
      Row1.setBorder(null);
      Row1.setBackground(Color.black);
      Row1.setForeground(Color.green);
      Row1.setFont(new Font("Monospaced", Font.BOLD, 21));

      Row2 = new JTextField();
      getContentPane().add(Row2);
      Row2.setBounds(ANDX,ANDY+ANDHeight,ANDWidth,ANDHeight);
      Row2.setBorder(null);
      Row2.setBackground(Color.black);
      Row2.setForeground(Color.green);
      Row2.setFont(new Font("Monospaced", Font.BOLD, 21));

      UnitLabel = new JLabel();
      getContentPane().add(UnitLabel);
      UnitLabel.setBounds(ANDX, ANDX, 20, 25);
      UnitLabel.setText("ID");
      UnitLabel.setDisplayedMnemonic('I');
      UnitLabel.setForeground(Color.black);

      UnitEdit = new JTextField();
      getContentPane().add(UnitEdit);
      UnitEdit.setBounds(ANDX+20,ANDX,40,25);
      UnitEdit.setBorder(BorderFactory.createLoweredBevelBorder());
      UnitEdit.setText(this.UnitID.toString());
      UnitEdit.setFocusAccelerator('I');

      TermLabel = new JLabel();
      getContentPane().add(TermLabel);
      TermLabel.setBounds(ANDX+20+40+10, ANDX, 40, 25);
      TermLabel.setText("Term");
      TermLabel.setDisplayedMnemonic('M');
      TermLabel.setForeground(Color.black);

      TermEdit = new JTextField();
      getContentPane().add(TermEdit);
      TermEdit.setBounds(ANDX+20+40+10+40,ANDX,40,25);
      TermEdit.setBorder(BorderFactory.createLoweredBevelBorder());
      getContentPane().add(TermEdit);
      TermEdit.setText(this.TermNum.toString());
      TermEdit.setFocusAccelerator('M');

      Connect = new JCheckBox();
      getContentPane().add(Connect);
      Connect.setBounds(ANDX+20+40+10+40+10+40, ANDX-5, 80, 25);
      Connect.setText("Connect");
      Connect.setMnemonic('N');

      MgrKey = new JCheckBox();
      getContentPane().add(MgrKey);
      MgrKey.setBounds(ANDX+20+40+10+40+10+40, ANDX+15, 80, 25);
      MgrKey.setText("MgrKey");
      MgrKey.setMnemonic('K');
      MgrKey.addActionListener(new ActionListener()
         {
         public void actionPerformed(ActionEvent e)
            {
            MgrKeyButtonPressed();
            }
         });

      StartBtn = new JButton();
      getContentPane().add(StartBtn);
      StartBtn.setBounds(ANDX+20+40+10+40+10+40+10+65, ANDX, 95, 35);
      StartBtn.setBorder(BorderFactory.createRaisedBevelBorder());
      StartBtn.setText("Start Term");
      StartBtn.addActionListener(new ActionListener()
         {
         public void actionPerformed(ActionEvent e)
            {
            StartButtonPressed();
            }
         });
      StartBtn.setMnemonic('A');

      Keyboard = new POSKybd();
      Keyboard.addPOSKybdListener(this);
      this.setTitle("TC Java Socket Client [Keymap " + Keyboard.prefix + "]" );
      getContentPane().add(Keyboard);

      ScrlPane = new JScrollPane();
      ScrlPane.setLayout(null);
      ScrlPane.setBorder(null);
      ScrlPane.setBounds(5, 315, 330, 165);

      Receipt = new JList();

      ReceiptModel = new DefaultListModel();
      ReceiptModel.ensureCapacity(1000);
      Receipt.setModel(ReceiptModel);
      Receipt.setFont(new java.awt.Font("Monospaced", 1, 14));
      Receipt.setFixedCellHeight(25);
      Receipt.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

      ScrlPane.getViewport().add(Receipt);
      ScrlPane.getViewport().setBounds(0, 0, 330, 165);
      ScrlPane.getViewport().setView(Receipt);
      ScrlPane.getViewport().setVisible(true);
      Receipt.setVisible(true);
      ScrlPane.setVisible(true);

      Receipt.setSelectedIndex(ReceiptModel.size()-1);
      Receipt.ensureIndexIsVisible(ReceiptModel.size()-1);
      getContentPane().add(ScrlPane);

      DIDocPresent = new JCheckBox();
      getContentPane().add(DIDocPresent);
      DIDocPresent.setBounds(5, 485, 120, 25);
      DIDocPresent.setText("DI Doc Present");
      DIDocPresent.setMnemonic('P');

      DIDocPresent.addActionListener(new ActionListener()
         {
         public void actionPerformed(ActionEvent e)
            {
            if (DIDocPresent.getModel().isSelected())
               {
               Term.getPrinter().putDIDocPresent(true);
               }
            else
               {
               Term.getPrinter().putDIDocPresent(false);
               }
            }
         });

      EnableSerial1 =  new JCheckBox();
      getContentPane().add(EnableSerial1);
      EnableSerial1.setBounds(5, 505, 120, 25);
      EnableSerial1.setText("Enable Ser1");

      EnableSerial2 =  new JCheckBox();
      getContentPane().add(EnableSerial2);
      EnableSerial2.setBounds(135, 505, 90, 25);
      EnableSerial2.setText("Enable Ser2");

      EnableVDisplay = new JCheckBox();
      getContentPane().add(EnableVDisplay);
      EnableVDisplay.setBounds(225, 485, 165, 25);
      EnableVDisplay.setText("Enable VDisplay");
      EnableVDisplay.setMnemonic('V');
      if (m_EnableVDisplay == 1)
         {
         EnableVDisplay.getModel().setSelected(true);
         }

      Enable4610 =  new JCheckBox();
      getContentPane().add(Enable4610);
      Enable4610.setBounds(225, 505, 165, 25);
      Enable4610.setText("4610 Printer");

      CodeMode = new JCheckBox();
      getContentPane().add(CodeMode);
      CodeMode.setBounds(135, 485, 90, 25);
      CodeMode.setText("CodeMode");
      CodeMode.setMnemonic('V');
      CodeMode.addActionListener(new ActionListener()
         {
         public void actionPerformed(ActionEvent e)
            {
            if (CodeMode.getModel().isSelected())
               {
               Keyboard.gCodeMode = 1;
               }
            else
               {
               Keyboard.gCodeMode = 0;
               }
            }
         });

      Term = new RPAMTerminal();
      Term.addRPAMEventListener(this);

      App = new RPAMApp();
      if (m_AutoConnectEnabled == 1)
         {
         Connect.getModel().setSelected(true);
         StartButtonPressed();
         }

      totals = new byte[50000];

      if (this.AppHardTotals == 1)
         {
         try
            {
            totalsIn = new FileReader(inputFile);
            for (x=0;x<50000;x++)
               {
               totals[x] = (byte)totalsIn.read();
               }
            totalsIn.close();
            }
         catch(Exception e)
            {
            for (x=0;x<50000;x++)
               {
               totals[x] = (byte)0;
               }

            FlushTotalsFile();
            }
         }
      }

   public void DoFileOp()
      {
      POSFile PFile;
      POSKeyedFile PKFile;
      PFile = new POSFile();
      PKFile = new POSKeyedFile();
      int x;
      int y;
      int BytesRead=0;
      int CumBytesRead;
      int Offset;
      byte[] buf = new byte[25];
      int rc;


      PFile.setUnitID(1);
      PFile.setName("R::ADX_UDT1\\FILEOP.DAT");


      // create the file with read/write/delete permissions
      PFile.Create(rpaFlgDelete + rpaFlgWrite + rpaFlgRead , 0, 0, 0);  //size was 0x400, 2nd param

      if (PFile.getErrorCode4690() == 0)
         {
         // now write some data to the file

         for (x=0;x<20;x++)
            {
            for (y=0;y<25;y++)
              buf[y] = (byte)(x + 0x30);

            PFile.Write(rpaSeekFP + rpaTruncate, buf, 25, 0);

            }
            // close the file
            PFile.Close();
         }
      else
         {
         System.out.println("Create of FILEOP.DAT failed " +
                                                    PFile.getErrorCode4690());
         }

         // now read in a couple of buffers from the file
         PFile.Open(rpaFlgRead, 0);
         if (PFile.getErrorCode4690() == 0)
            {
            // read 25 bytes from offset 35
            BytesRead = PFile.Read(rpaSeekBOF, buf, 25, 35);

            // read 12 bytes from offset 47
            BytesRead = PFile.Read(rpaSeekBOF, buf, 12, 47);

            // now read sequentially through the file
            BytesRead = 1;
            CumBytesRead = 0;
            Offset = 0;
            while (BytesRead > 0)
               {
               BytesRead = PFile.Read(rpaSeekBOF, buf, 24, Offset);
               if (BytesRead == 0)
                  {
                  System.out.println("EOF found, cumulative bytes read " +
                                                                 CumBytesRead);
                  System.out.println("ErrCode  " + PFile.getErrorCode4690());
                  }
               else if (BytesRead <0)
                  {
                  System.out.println("4690 error " + PFile.getErrorCode4690());
                  }
               else
                  {
                  CumBytesRead = CumBytesRead + BytesRead;
                  Offset = Offset + BytesRead;
                  }
               }
            // close the file
            PFile.Close();
            }

      // now do some keyed file ops
      // set the unit ID and name
      // unit ID must match unit ID of the terminal you want to
      // use
      PKFile.setUnitID(1);
      PKFile.setName("R::ADX_UDT1\\KEYED.FIL");

      // open the file with read/write permissions
      PKFile.Open(rpaFlgWrite + rpaFlgRead , 0);
      if (PKFile.getErrorCode4690() == 0)
         {
         // write a record with key value 'KEY02' to the file
         // the sample keyed file 'KEYED.FIL' has record length
         // of 20 with a key length of 5
         buf = StringToByteArr("KEY02X_____________Y");
         rc = PKFile.Write(0, buf, 20);
         buf = StringToByteArr("KEY98XjjfjjfjjfjjfjY");
         rc = PKFile.Write(0, buf, 20);
         buf = StringToByteArr("KEY99X9_9_9_9_9_9_9Y");
         rc = PKFile.Write(0, buf, 20);
         buf = StringToByteArr("KEY9AX9a9a9a9a9a9a9Y");
         rc = PKFile.Write(0, buf, 20);

         // put the key value to read in the buffer
         buf = StringToByteArr("                    ");
         buf = StringToByteArr("KEY02               ");

         // read the data
         rc = PKFile.Read(0, buf, 20, 5);

         // delete some records
         buf = StringToByteArr("KEY01");
         rc = PKFile.DeleteRecord(buf, 5);
         buf = StringToByteArr("KEY98");
         rc = PKFile.DeleteRecord(buf, 5);

         // close the file
         PKFile.Close(0);
         }
      }

   public void MgrKeyButtonPressed()
      {
      int keypos = (MgrKey.getModel().isSelected()) ? 1 : 0;
      Term.getKeyboard().setKeylockPosition(keypos);
      System.out.println("Mgr key " + keypos);
      }

   public void StartButtonPressed()
      {
      try
      {
      if (TCAddr.compareTo("") != 0)
         {
         App.setTCServerAddresses(TCAddr, "");
         }
      App.setTracing(1);
      App.setTermNumAssignMode(rpaAppTermNum);
      /* App.setStartingTermNum(9); */
      UnitID = Integer.valueOf(UnitEdit.getText());
      Term.setUnitID(UnitID.intValue());

      Term.getPrinter().setDeviceID(rpaMod34prt);
      Term.getPrinter().putMICRAttached(true);
      Row1.setText("Waiting For");
      Row2.setText("Online Event");
      App.setOptimizeDisplay(0);
      App.setStoreNum(StoreNum.intValue());   /* TESTING purposes only       */

      if (EnableSerial1.getModel().isSelected())
         {
         Term.getSerial1().setDeviceEnabled();
         }

      if (EnableSerial2.getModel().isSelected())
         {
         Term.getSerial2().setDeviceEnabled();
         }

      if (Enable4610.getModel().isSelected())
         {
         Term.getPrinter().setDeviceID(rpa4610prt);
         }
      else
         {
         Term.getPrinter().setDeviceID(rpaMod34prt);
         }

      if (AppHardTotals != 0)
         {
         Term.getHardTotals().setDeviceResponseMode(rpaAppDeviceResponse);
         }
/*
JJF - 10/27/03
Bug was found and fixed in RPAMFUNC client code.  Auto response should have
been the default but was not.  This call is no longer required.
      else
         {
         Term.getHardTotals().setDeviceResponseMode(rpaAutoDeviceResponse);
         }
*/

      Term.getSerial1().addSerialEventListener(Serial1Handler);
      Term.getSerial2().addSerialEventListener(Serial2Handler);
      Term.getVDisplay().addVDisplayEventListener(this);

      Term.getScale().Enable();

/* Enable the VDISPLAY device if asked to do so. */
      if (EnableVDisplay.getModel().isSelected())
         {
         POSVDisplay vd = Term.getVDisplay();
         Term.getVDisplay().setDeviceEnabled();

         /*
         This just shows that the properties of the VDISPLAY object
         are invalid until the first CursorVisibilityChangeEvent
         is received
         */

         /*
         System.out.println("fmt: " + vd.DisplayFormat);
         System.out.println("cur: " + vd.CursorVisible);
         System.out.println("undl: " + vd.VGAUnderlining);
         System.out.println("intens: " + vd.VGAIntensifyBackground);
         System.out.println("attrtype: " + vd.AttributeType);
         System.out.println("curr attr: " + vd.CurrentAttribute);
         System.out.println("disptype: " + vd.DisplayType);
         */
         }

                                       /* it's highly reccommeded that you   */
                                       /* turn off field level input         */
                                       /* processing unless you know exactly */
                                       /* why you want it.                   */
      Term.getIOProc().putFieldLevelInputMode(FL_NONE);

      Term.getMsr().setDeviceID(0x48);

      if (Connect.getModel().isSelected())
         {
         if (AppHardTotals != 0)
            {
            Term.setTermNum(0);
            TermEdit.setText("0");
            }
         else
            {
            Term.setTermNum(Integer.valueOf(TermEdit.getText()).intValue());
            }
         Term.Connect();
         }
      else
         {
         Row1.setText(Term.getANDisplay().getRow1Text());
         Row2.setText(Term.getANDisplay().getRow2Text());
         }
      }
      catch(Exception e)
         {
         e.printStackTrace();
         }
      }

   /*
   Called by the POSKybd class when a button is pressed
   */
   public void ButtonPressed(POSKybdButtonPressedEvent evt)
      {
      if (evt.FCode == 900)
         {
         DoFileOp();
         }
      else if (evt.FCode == 901)
         {
         String tk1 = "B4387751111110^T/^05121010123456789";
         String tk2 = "4387751111110=051210";
         String tk3 = "B4387751111110^T/^05121010123456789";

         Term.getMsr().SendMsrData(tk1,tk1.length(),tk2,tk2.length(),tk3,tk3.length());
         }
      else if (evt.FCode == 902)
         {
         int label_type = LBL_UPC_A;
         String label_data = "079200201012";
         Term.getScanner().SendScannerData(label_type, label_data);
         }
      else
         {
         Term.getKeyboard().SendKeyboardData(evt.FCode);
         }
      }

   private void jbInit() throws Exception
      {
      this.addWindowListener(new java.awt.event.WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            this_windowClosing(e);
         }
      });
      this.getContentPane().add(jPanel1, BorderLayout.CENTER);
      }

   void this_windowClosing(WindowEvent e)
      {
      System.exit(0);
      }

   /* RPAM Event handlers */
   public void Offline(OfflineEvent evt) {};
   public void ConnectTimeout(ConnectTimeoutEvent evt) {};
   public void Display(DisplayEvent evt) {};
   public void Print(PrintEvent evt) {};
   public void IOProcWait(IOProcWaitEvent evt) {};
   public void PrintEx(PrintExEvent evt)
      {

      if (evt.Station == CR)
         {
         if (evt.Command == CMD_PRINT_DATA)
            {
            /* regular print data */
            ReceiptModel.addElement(ByteArrayToString(evt.Data, 0, evt.DataLen));
            Receipt.setSelectedIndex(ReceiptModel.size()-1);
            Receipt.ensureIndexIsVisible(ReceiptModel.size()-1);
            }
         else if (evt.Command == PARS46_CMDCODE_PRINT_LF)
            {
            /* line feed command, add blank line */
            ReceiptModel.addElement("");
            }
         }
      else if ((evt.Station == DI) && (evt.Command == PARS46_CMDCODE_MICR_READ1B))
         {
         /* send an error every other time */
         System.out.println("Sending micr data");
         if ((exe_cnt % 2) != 0)
            {
            Term.getPrinter().SendMICRData("?", 0x8000000);
            }
         else
            {
            Term.getPrinter().SendMICRData("abcdefghij", 0);
            }
         exe_cnt++;
         }
      };

   public void ActivateMICR(ActivateMICREvent evt)
      {
      System.out.println("Micr activated");
      Term.getPrinter().SendMICRData("T461004610T123456789A", 0);
      };

   public void Lock(LockEvent evt) {};
   public void Unlock(UnlockEvent evt) {};
   public void ScannerUnlock(ScannerUnlockEvent evt) {};
   public void ScannerLock(ScannerLockEvent evt) {};
   public void Online(OnlineEvent evt)
      {
      Row1.setText("Terminal Online");
      Row2.setText("");
      };

   public void DisplayEx(DisplayExEvent evt)
      {
      if (evt.Device == 0)
         {
         Row1.setText(Term.getANDisplay().getRow1Text());
         Row2.setText(Term.getANDisplay().getRow2Text());
         }
      };

   public void WaitLight(WaitLightEvent evt) {};
   public void MessageLight(MessageLightEvent evt) {};
   public void OfflineLight(OfflineLightEvent evt)
      {
      System.out.println("OfflineLight event " + evt.NewValue);
      };
   public void FieldLevelInput2(FieldLevelInput2Event evt) {};
   public void DrawerOpen(DrawerOpenEvent evt) {};
   public void FieldLevelInput(FieldLevelInputEvent evt) {};
   public void MsrLock(MsrLockEvent evt) {};
   public void MsrUnlock(MsrUnlockEvent evt) {};

   public void Tone(ToneEvent evt)
      {
      //System.out.println("Tone freq " + evt.Frequency + " dur " + evt.Duration);
      }

   static int call_num=0;

   public void ScaleRead(ScaleReadEvent evt)
      {
      Term.getScale().SendScaleData(0);
/*
      if (call_num == 0)
         {
         System.out.println("Sending 0 weight");
         Term.getScale().SendScaleData(0);
         }
      else
         {
         System.out.println("Sending 125 weight");
         Term.getScale().SendScaleData(125);
         }

      if (call_num == 1)
         call_num = 0;
      else
         call_num = 1;
*/
      };

   public void UserData(UserDataEvent evt)
      {
      };

   public void RunningTotalData(RunningTotalDataEvent evt) {};

   public void TotalsWrite(TotalsWriteEvent evt)
      {
      int x;
      System.out.println("TotalsWrite Event len " + evt.Length);
      for (x=0;x<evt.Length;x++)
         {
         totals[evt.Offset+x] = evt.Data[x];
         }

      FlushTotalsFile();

      Term.getHardTotals().SendTotalsWriteResponse(evt.Length);
      }

   public void FlushTotalsFile()
      {
      try                                                            /* NYH */
         {                                                           /* NYH */
         totalsOut = new FileWriter(outputFile);                     /* NYH */
         totStr = new String(totals);                                /* NYH */
         totalsOut.write(totStr);                                    /* NYH */
         totalsOut.close();                                          /* NYH */
         }                                                           /* NYH */
      catch(Exception e)                                             /* NYH */
         {                                                           /* NYH */
         }                                                           /* NYH */
      }


   public void TotalsRead(TotalsReadEvent evt)
      {
      byte [] barr;
      int x;
      System.out.println("TotalsRead Event len " + evt.Length);

      barr = new byte[evt.Length];

      for (x=0; x<evt.Length;x++)
         {
         barr[x] = totals[evt.Offset+x];
         }

      Term.getHardTotals().SendTotalsData(barr, evt.Length);
      };

   public void TermNumberChanged(TermNumberChangedEvent evt)
      {
      System.out.println("Term number has changed");
      };

   public void OfflineTotalsData(OfflineTotalsDataEvent evt) {};
   public void PrintEject(PrintEjectEvent evt) {};
   public void ReceiptCut(ReceiptCutEvent evt) {};
   public void TermIPLControl(TermIPLControlEvent evt) {};
   public void TermReload(TermReloadEvent evt) {};
   public void ActivateMarqueeDisplay(ActivateMarqueeDisplayEvent evt) {};
   public void DeactivateMarqueeDisplay(DeactivateMarqueeDisplayEvent evt) {};
   public void LoadMarqueeDisplay(LoadMarqueeDisplayEvent evt) {};

   /**************************************************************************/
   /* Event that gets fired when ANDisplay/ANDisplay2 filtering is turned on */
   /* and the app displays something on one of the displays                  */
   /**************************************************************************/
   public void PassiveANDisplayFilter(PassiveANDisplayFilterEvent evt)
      {
      if (evt.Device == 0)
         {
         Row1.setText(Term.getANDisplay().getRow1Text());
         Row2.setText(Term.getANDisplay().getRow2Text());
         }
//    dbg.print("PassiveANDisplayFilter");
      }

   /**************************************************************************/
   /* Future                                                                 */
   /**************************************************************************/
   public void PassiveJavaCallFilter(PassiveJavaCallFilterEvent evt)
      {
      dbg.print("PassiveJavaCallFilter");
      }

   /**************************************************************************/
   /* Future                                                                 */
   /**************************************************************************/
   public void PassiveMSRFilter(PassiveMSRFilterEvent evt)
      {
      dbg.print("PassiveMSRFilter");
      }

   /**************************************************************************/
   /* Event that gets fired when Printer filtering is turned on the app      */
   /* reads or writes to the printer                                         */
   /**************************************************************************/
   public void PassivePrinterFilter(PassivePrinterFilterEvent evt)
      {
      String act;
      if (evt.Action == rpaFilterActionRead)
         {
         act = "READ";
         }
      else if (evt.Action == rpaFilterActionWrite)
         {
         act = "WRITE";
         }
      else
         {
         act = "???";
         }

      String stat;
      if (evt.Station == rpaCRStation)
         {
         stat = "CR";
         }
      else if (evt.Station == rpaDIStation)
         {
         stat = "DI";
         }
      else if (evt.Station == rpaSJStation)
         {
         stat = "SJ";
         }
      else
         {
         stat = "??";
         }

      dbg.print("PrinterFilter Action:" + act + " Station:" + stat +
                     " Cmd: 0x" + java.lang.Integer.toHexString(evt.Command) +
                                                      " LF: " + evt.LineFeeds);
      dbg.hexlog(evt.Data, "filterdata");
      }

   /**************************************************************************/
   /* Event that gets fired when Serial filtering is turned on the app       */
   /* reads or writes to the printer                                         */
   /**************************************************************************/
   public void PassiveSerialFilter(PassiveSerialFilterEvent evt)
      {

      String act;
      if (evt.Action == rpaFilterActionRead)
         {
         act = "READ";
         }
      else if (evt.Action == rpaFilterActionWrite)
         {
         act = "WRITE";
         }
      else
         {
         act = "???";
         }

      dbg.print("SerialFilter Action:" + act + " Port:" + evt.Port );
      dbg.hexlog(evt.Data, "filterdata");
      }

   public String ByteArrayToString(byte[] arr, int start, int len)
      {
      String RetVal = "";
      int i;
      for (i=start;i<start+len;i++)
         {
         RetVal = RetVal + (char)arr[i];
         }
      return RetVal;
      }
      class SerialEventHandler implements qvs.SerialEventListener
      {
      int Port;

      public SerialEventHandler(int pPort)
         {
         Port = pPort;
         }

      public void Open(SerialOpenEvent evt)
         {
         int GetLongVal;
         System.out.println("Serial open for port " + Port);
         System.out.println("Baud " + evt.Speed + " Parity " + evt.Parity);
         System.out.println("DBits " + evt.DataBits + " SBits " + evt.StopBits);
         System.out.println("Buffer size " + evt.BuffSize);

                                       /* send a good open return code       */
                                       /* and send a getlong status update   */
                                       /* to TC.  Note: the only bits that   */
                                       /* may be set in a getlong from the   */
                                       /* client are the ones shown here     */
         GetLongVal = s1DataLost | s2DSRActive | s2CTSActive | s2ParityError |
                                             s2FramingError | s2BreakDetected;

         if (Port == 1)
            {
            Term.getSerial1().SendOpenRc(0);
            Term.getSerial1().UpdatePortStatus(GetLongVal);
            }
         else if (Port == 2)
            {
            Term.getSerial2().SendOpenRc(0);
            Term.getSerial2().UpdatePortStatus(GetLongVal);
            }
         }

      public void PutLong(SerialPutLongEvent evt)
         {
         System.out.println( "PutLong on port " + Port + " Timeout " +
                                  evt.TimeOut + " Stat " + evt.PortStatusInfo);

                                       /* send a good  return code back to   */
                                       /* the .286                           */
         POSSerialDevice dev = (POSSerialDevice)(evt.getSource());
//         dev.SendPutLongRc((evt.TimeOut << 24) + (evt.PortStatusInfo << 16) + 0x26);
         dev.SendPutLongRc(0);
         }

      public void Write(SerialWriteEvent evt)
         {
         System.out.println("Serial write for " + evt.Length + " bytes.");
         String StrData = ByteArrToString(evt.Data,0,evt.Length);
         System.out.println("[" + StrData + "]" );

                                       /* give an rc back for the number of  */
                                       /* bytes written                      */
         POSSerialDevice dev = (POSSerialDevice)(evt.getSource());
         dev.SendWriteRc(evt.Length);

         }

      public void Close(SerialCloseEvent evt)
         {
         System.out.println("Close for port " + Port);
         }
      }


                                       /* VDISPLAY event handlers            */
   public void CursorVisibilityChange(CursorVisibilityChangeEvent evt)
      {
      POSVDisplay vd = Term.getVDisplay();
      System.out.println("CursorVisibilityChange, cursor is " + evt.CursorVisible);

      if (FirstVDispEventReceived == 0)
         {
         /*
         After the first VDISPLAY event, the properties of the
         object are available, read them now
         */

         System.out.println("fmt: " + vd.DisplayFormat);
         System.out.println("cur: " + vd.CursorVisible);
         System.out.println("undl: " + vd.VGAUnderlining);
         System.out.println("intens: " + vd.VGAIntensifyBackground);
         System.out.println("attrtype: " + vd.AttributeType);
         System.out.println("curr attr: " + vd.CurrentAttribute);
         System.out.println("disptype: " + vd.DisplayType);
         FirstVDispEventReceived = 1;
         }
      }

   public void DisplayFormatChange(DisplayFormatChangeEvent evt)
      {
      System.out.println("DisplayFormatChange, fmt is " + evt.DisplayFormat);
      }
   public void Display(VDisplayEvent evt)
      {
      System.out.println("VDisplay len " + evt.Length + " flg " + evt.Flags + " row " + evt.Row + " col " + evt.Col);
      System.out.println("[" + evt.Text + "]");
      }
   }


class POSKybdButtonPressedEvent extends EventObject
   {
   public int FCode;

   public POSKybdButtonPressedEvent(Object source, int FC)
      {
      super(source);
      FCode = FC;
      }
   }

interface POSKybdListener extends java.util.EventListener
   {
   public void ButtonPressed(POSKybdButtonPressedEvent evt);
   }


class QButton extends JButton
   {
   public int FCode;
   }

class POSKybd extends JPanel implements ActionListener
   {
   public String prefix;
   Vector Listeners = new Vector();

   /*
   QButton Button0;
   QButton Button1;
   QButton Button2;
   QButton Button3;
   QButton Button4;
   QButton Button5;
   QButton Button6;
   QButton Button7;
   QButton Button8;
   QButton Button9;
   */
   QButton ButtonA;
   QButton ButtonB;
   QButton ButtonC;
   QButton ButtonD;
   QButton ButtonE;
   QButton ButtonF;
   QButton ButtonG;
   QButton ButtonH;

   QButton ButtonS1;
   QButton ButtonS2;

   public int gCodeMode=0;
   String CodeString="";

   public void actionPerformed(ActionEvent e)
      {
      int TempInt=0;
      int x;
      QButton btn = (QButton)(e.getSource());
      if (gCodeMode == 1)
         {
         if ((btn.FCode == 80 ||
             btn.FCode == 95) && (CodeString.length() > 0))
            {
            for(x=0;x<CodeString.length();x++)
               {
               TempInt = (TempInt * 10) + (int)(CodeString.charAt(x)-0x30);
       //        System.out.println("TempInt "+ TempInt);
               }

            FireEvent(TempInt);

            CodeString = "";
            }
         else if (btn.FCode >= 48 && btn.FCode <= 57)
            {
            CodeString = CodeString + (char)btn.FCode;
         //   System.out.println("CodeString " + CodeString);
            }
         }
      else
         {
         FireEvent(btn.FCode);
         }
      }

   public POSKybd()
      {
      QButton btn;
      Properties p = new Properties();
      String prop_name;
      String prop_val;
      int prop_val_int;

      setLayout(null);
      setBounds(5,110,330,205);

      try
         {
         p.load(new FileInputStream("keymap.pro"));
         }
      catch (Exception e)
         {
         System.out.println("Unable to load keymap file keymap.pro");
         System.exit(1);
         }

      prefix = p.getProperty("Prefix");

      if (prefix.length() > 0)
         {
         prefix = prefix + ".";
         }

      try
         {
         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(0,120,80,40);
         btn.addActionListener(this);
         prop_name = prefix + "Button0.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "Button0.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "Button0.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));

         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(0,80,40,40);
         btn.addActionListener(this);
         prop_name = prefix + "Button1.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "Button1.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "Button1.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));

         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(40,80,40,40);
         btn.addActionListener(this);
         prop_name = prefix + "Button2.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "Button2.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "Button2.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));

         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(80,80,40,40);
         btn.addActionListener(this);
         prop_name = prefix + "Button3.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "Button3.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "Button3.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));

         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(0,40,40,40);
         btn.addActionListener(this);
         prop_name = prefix + "Button4.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "Button4.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "Button4.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));

         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(40,40,40,40);
         btn.addActionListener(this);
         prop_name = prefix + "Button5.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "Button5.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "Button5.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));

         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(80,40,40,40);
         btn.addActionListener(this);
         prop_name = prefix + "Button6.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "Button6.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "Button6.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));

         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(0,0,40,40);
         btn.addActionListener(this);
         prop_name = prefix + "Button7.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "Button7.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "Button7.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));

         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(40,0,40,40);
         btn.addActionListener(this);
         prop_name = prefix + "Button8.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "Button8.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "Button8.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));

         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(80,0,40,40);
         btn.addActionListener(this);
         prop_name = prefix + "Button9.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "Button9.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "Button9.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));

         btn = new QButton();
         this.add(btn);
         btn.setBorder(BorderFactory.createRaisedBevelBorder());
         btn.setBounds(80,120,40,40);
         btn.addActionListener(this);
         prop_name = prefix + "ButtonSlash.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         btn.FCode = prop_val_int;
         prop_name = prefix + "ButtonSlash.Text";
         prop_val = p.getProperty(prop_name);
         btn.setText(prop_val);
         prop_name = prefix + "ButtonSlash.Mnemonic";
         prop_val = p.getProperty(prop_name);
         btn.setMnemonic(prop_val.charAt(0));
         }
      catch (Exception e)
         {
         System.out.println("Exception processing keymap.pro");
         System.out.println("Entries are case sensitive!!");
         System.out.println("");

         e.printStackTrace();
         }

      ButtonA = new QButton();
      this.add(ButtonA);
      ButtonA.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonA.setBounds(160,0,80,40);
      ButtonA.addActionListener(this);

      ButtonB = new QButton();
      this.add(ButtonB);
      ButtonB.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonB.setBounds(160,40,80,40);
      ButtonB.addActionListener(this);

      ButtonC = new QButton();
      this.add(ButtonC);
      ButtonC.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonC.setBounds(160,80,80,40);
      ButtonC.addActionListener(this);

      ButtonD = new QButton();
      this.add(ButtonD);
      ButtonD.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonD.setBounds(160,120,80,40);
      ButtonD.addActionListener(this);

      ButtonE = new QButton();
      this.add(ButtonE);
      ButtonE.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonE.setBounds(240,0,80,40);
      ButtonE.addActionListener(this);

      ButtonF = new QButton();
      this.add(ButtonF);
      ButtonF.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonF.setBounds(240,40,80,80);
      ButtonF.addActionListener(this);

      ButtonG = new QButton();
      this.add(ButtonG);
      ButtonG.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonG.setBounds(240,120,80,40);
      ButtonG.addActionListener(this);


      ButtonS1 = new QButton();
      this.add(ButtonS1);
      ButtonS1.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonS1.setBounds(160,160,80,40);
      ButtonS1.setText("S1");
      ButtonS1.addActionListener(this);
      ButtonS1.FCode=1;

      ButtonS2 = new QButton();
      this.add(ButtonS2);
      ButtonS2.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonS2.setBounds(240,160,80,40);
      ButtonS2.setText("S2");
      ButtonS2.addActionListener(this);
      ButtonS2.FCode=2;

      try
         {
         prop_name = prefix + "ButtonA.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         ButtonA.FCode = prop_val_int;
         prop_name = prefix + "ButtonA.Text";
         prop_val = p.getProperty(prop_name);
         ButtonA.setText(prop_val);
         prop_name = prefix + "ButtonA.Mnemonic";
         prop_val = p.getProperty(prop_name);
         ButtonA.setMnemonic(prop_val.charAt(0));


         prop_name = prefix + "ButtonB.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         ButtonB.FCode = prop_val_int;
         prop_name = prefix + "ButtonB.Text";
         prop_val = p.getProperty(prop_name);
         ButtonB.setText(prop_val);
         prop_name = prefix + "ButtonB.Mnemonic";
         prop_val = p.getProperty(prop_name);
         ButtonB.setMnemonic(prop_val.charAt(0));


         prop_name = prefix + "ButtonC.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         ButtonC.FCode = prop_val_int;
         prop_name = prefix + "ButtonC.Text";
         prop_val = p.getProperty(prop_name);
         ButtonC.setText(prop_val);
         prop_name = prefix + "ButtonC.Mnemonic";
         prop_val = p.getProperty(prop_name);
         ButtonC.setMnemonic(prop_val.charAt(0));


         prop_name = prefix + "ButtonD.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         ButtonD.FCode = prop_val_int;
         prop_name = prefix + "ButtonD.Text";
         prop_val = p.getProperty(prop_name);
         ButtonD.setText(prop_val);
         prop_name = prefix + "ButtonD.Mnemonic";
         prop_val = p.getProperty(prop_name);
         ButtonD.setMnemonic(prop_val.charAt(0));


         prop_name = prefix + "ButtonE.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         ButtonE.FCode = prop_val_int;
         prop_name = prefix + "ButtonE.Text";
         prop_val = p.getProperty(prop_name);
         ButtonE.setText(prop_val);
         prop_name = prefix + "ButtonE.Mnemonic";
         prop_val = p.getProperty(prop_name);
         ButtonE.setMnemonic(prop_val.charAt(0));


         prop_name = prefix + "ButtonF.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         ButtonF.FCode = prop_val_int;
         prop_name = prefix + "ButtonF.Text";
         prop_val = p.getProperty(prop_name);
         ButtonF.setText(prop_val);
         prop_name = prefix + "ButtonF.Mnemonic";
         prop_val = p.getProperty(prop_name);
         ButtonF.setMnemonic(prop_val.charAt(0));


         prop_name = prefix + "ButtonG.FCode";
         prop_val = p.getProperty(prop_name);
         prop_val_int = new Integer(prop_val).intValue();
         ButtonG.FCode = prop_val_int;
         prop_name = prefix + "ButtonG.Text";
         prop_val = p.getProperty(prop_name);
         ButtonG.setText(prop_val);
         prop_name = prefix + "ButtonG.Mnemonic";
         prop_val = p.getProperty(prop_name);
         ButtonG.setMnemonic(prop_val.charAt(0));
         }
      catch (Exception e)
         {
         System.out.println("Exception processing keymap.pro");
         System.out.println("Entries are case sensitive!!");
         System.out.println("");

         e.printStackTrace();
         }

      setVisible(true);
      }

   public synchronized void addPOSKybdListener(POSKybdListener listener)
      {
      if (!Listeners.contains(listener))
         {
         Listeners.addElement(listener);
         }
      }

   public synchronized void removePOSKybdListener(POSKybdListener listener)
      {
      if (Listeners.contains(listener))
         {
         Listeners.removeElement(listener);
         }
      }

   private void FireEvent(int FCode)
      {
      Vector v;

      synchronized(this)
         {
         v = (Vector) Listeners.clone();
         }

      int cnt = v.size();

      for (int i=0; i<cnt; i++)
         {
         POSKybdListener Listener = (POSKybdListener)v.elementAt(i);
         POSKybdButtonPressedEvent evt =
                                    new POSKybdButtonPressedEvent(this, FCode);
         Listener.ButtonPressed(evt);
         }
      }
   }
